#
# sysmt_adm.pm
# ------------
#
# Design and Implementation by Bjoern Lemke               
#           
# (C)opyright 2010 by Bjoern Lemke
#                                              
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#

package PerlSpace::SysMtAdmin;

sub sysmtDivMaster
{

    my ( $dbh, $user ) = @_;

    my $dbdata;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_divmaster.html";

        
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";

}

sub sysmtSetSystemParameter
{

    my ( $dbh, $user, $pname, $pval ) = @_;
    
    $sth = $dbh->prepare("update sysmt_sysparam set pval = ? where pname = ?;");
    $sth->bind_param(1, $pval, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $pname, DBI::SQL_VARCHAR);
    $sth->execute;
    $sth->finish;

    sysmtDivMaster($dbh, $user);
}

sub sysmtMtDelete
{

    my ( $dbh, $user, $mid ) = @_;

    my $dbdata;

    $sth = $dbh->prepare("delete from sysmt_mtlog where mid = ?;");
   
    $sth->bind_param(1, $mid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    
    $sth = $dbh->prepare("delete from sysmt_mt where mid = ?;");
   
    $sth->bind_param(1, $mid, DBI::SQL_INTEGER);

    $sth->execute;
    
    $sth->finish;    

    return PerlSpace::SysMtAdmin::sysmtDivMaster($dbh, $user);

}

sub sysmtMtUnlock
{

    my ( $dbh, $user, $mid ) = @_;

    my $dbdata;

    $sth = $dbh->prepare("update sysmt_mt set lockby = null where mid = ?;");
   
    $sth->bind_param(1, $mid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    return PerlSpace::SysMtAdmin::sysmtDivMaster($dbh, $user);

}



1;
