#
# sysmt_fstmpl.pm
# ---------------
#
# Design and Implementation by Bjoern Lemke               
#           
# (C)opyright 2011 by Bjoern Lemke
#                                              
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#

package PerlSpace::SysMtFileSysTmpl;

sub sysmtFileSysTmplMaster
{

    my ( $dbh, $user ) = @_;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_fstmplmaster.html";


    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";

}

sub sysmtFileSysTmplList
{
    
    my ( $dbh, $user, $fstmplname) = @_;    

    my $stmt = "select tmplid, fstmplname, fstmpltype from sysmt_filesystmpl where fstmplname like '%" . $fstmplname . "%'";    
    my $ordering = "order by fstmpltype, fstmplname";
 
    sysmtFileSysTmplSearchExecuteList($dbh, $user, $stmt, $ordering);

    return 0;    

}

sub sysmtFileSysTmplSearchExecuteList
{
    
    my ( $dbh, $user, $stmt, $ordering ) = @_;

    my $sth = $dbh->prepare($stmt . " " . $ordering . ";");

    $sth->execute;
    
    my $dbdata;

    $$dbdata{'stmt'} = $stmt;

    my $tmplid;
    my $fstmplname;
    
    my $i=0;
    while ( ($tmplid, $fstmplname, $fstmpltype ) = $sth->fetchrow_array) 
    {

	$$dbdata{'fstmpllist'}[$i]{'tmplid'} = $tmplid;
	$$dbdata{'fstmpllist'}[$i]{'fstmplname'} = $fstmplname;
	$$dbdata{'fstmpllist'}[$i]{'fstmpltype'} = $fstmpltype;

	$i++;
    }
    
    $sth->finish;    

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_fstmpllist.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });

    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";


    return 0;
}


sub sysmtFileSysTmplBase
{    
    my ( $dbh, $user, $tmplid ) = @_;
    
    my $dbdata;

    # reached fs tmpl retrievel
    $stmt="select fstmplname, fstmpltype, fstmpldesc, fstmplrule from sysmt_filesystmpl where tmplid = ?;";
    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);

    $sth->execute;

    ( $fstmplname, $fstmpltype, $fstmpldesc, $fstmplrule ) = $sth->fetchrow_array;     
    
    $sth->finish;

    $$dbdata{'tmplid'} = $tmplid;
    $$dbdata{'fstmplname'} = $fstmplname;
    $$dbdata{'fstmpltype'} = $fstmpltype;
    $$dbdata{'fstmpldesc'} = $fstmpldesc;
    $$dbdata{'fstmplrule'} = $fstmplrule;

    # fs retrievel
    $stmt="select fsid, fstype, fspath, fsvg, fslv, fsopt, fssizesmall, fssizebig from sysmt_filesystmplentry where tmplid = ? order by fsvg, fspath;";

    $sth = $dbh->prepare($stmt);

    $sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);

    $sth->execute;
        
    my $fsid;
    my $fstype;
    my $fspath;
    my $fsvg;
    my $fslv;
    my $fssizesmall;
    my $fssizebig;

    $i=0;
    while ( ($fsid, $fstype, $fspath, $fsvg, $fslv, $fsopt, $fssizesmall, $fssizebig ) = $sth->fetchrow_array) 
    {
	$fspath =~ s/</&lt;/g;
	$fspath =~ s/>/&gt;/g;

	$fsvg =~ s/>/&gt;/g;
	$fsvg =~ s/</&lt;/g;

	$$dbdata{'fslist'}[$i]{'fsid'} = $fsid;
	$$dbdata{'fslist'}[$i]{'fstype'} = $fstype;
	$$dbdata{'fslist'}[$i]{'fspath'} = $fspath;
	$$dbdata{'fslist'}[$i]{'fsvg'} = $fsvg;
	$$dbdata{'fslist'}[$i]{'fslv'} = $fslv;
	$$dbdata{'fslist'}[$i]{'fsopt'} = $fsopt;
	$$dbdata{'fslist'}[$i]{'fssizesmall'} = $fssizesmall;
	$$dbdata{'fslist'}[$i]{'fssizebig'} = $fssizebig;
	$i++;
    }
    
    $sth->finish;    


    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_fstmplbase.html";    

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
    
}

sub sysmtFileSysTmplFS
{    
    my ( $dbh, $user, $tmplid ) = @_;
    
    my $dbdata;

    # reached fs tmpl retrievel
    $stmt="select fstmplname, fstmpltype, fstmpldesc, fstmplrule from sysmt_filesystmpl where tmplid = ?;";
    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);

    $sth->execute;

    ( $fstmplname, $fstmpltype, $fstmpldesc, $fstmplrule ) = $sth->fetchrow_array;     
    
    $sth->finish;

    $$dbdata{'tmplid'} = $tmplid;
    $$dbdata{'fstmplname'} = $fstmplname;
    $$dbdata{'fstmpltype'} = $fstmpltype;
    $$dbdata{'fstmpldesc'} = $fstmpldesc;
    $$dbdata{'fstmplrule'} = $fstmplrule;

    # fs retrievel
    $stmt="select fsid, fstype, fspath, fsvg, fslv, fsopt, fssizesmall, fssizebig from sysmt_filesystmplentry where tmplid = ? order by fsvg, fspath;";

    $sth = $dbh->prepare($stmt);

    $sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);

    $sth->execute;
        
    my $fsid;
    my $fstype;
    my $fspath;
    my $fsvg;
    my $fslv;
    my $fssizesmall;
    my $fssizebig;

    $i=0;
    while ( ($fsid, $fstype, $fspath, $fsvg, $fslv, $fsopt, $fssizesmall, $fssizebig ) = $sth->fetchrow_array) 
    {
	$fspath =~ s/</&lt;/g;
	$fspath =~ s/>/&gt;/g;

	$fsvg =~ s/>/&gt;/g;
	$fsvg =~ s/</&lt;/g;

	$$dbdata{'fslist'}[$i]{'fsid'} = $fsid;
	$$dbdata{'fslist'}[$i]{'fstype'} = $fstype;
	$$dbdata{'fslist'}[$i]{'fspath'} = $fspath;
	$$dbdata{'fslist'}[$i]{'fsvg'} = $fsvg;
	$$dbdata{'fslist'}[$i]{'fslv'} = $fslv;
	$$dbdata{'fslist'}[$i]{'fsopt'} = $fsopt;
	$$dbdata{'fslist'}[$i]{'fssizesmall'} = $fssizesmall;
	$$dbdata{'fslist'}[$i]{'fssizebig'} = $fssizebig;
	$i++;
    }
    
    $sth->finish;    


    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;


    $$dbdata{'content'} = "sysmt_fstmplfs.html";    

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";


    
    return 0;
    
}

sub sysmtFileSysTmplNew
{

    my ( $dbh, $user ) = @_;

    my $dbdata;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_fstmplnew.html";    

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
}


sub sysmtFileSysTmplCreate
{

    my ( $dbh, $user, $fstmplname, $fstmpltype, $fstmplrule, $fstmpldesc) = @_;

    my $dbdata;

    my $tmplid;

    # trim left and right whitespaces
    $fstmplname =~ s/^\s+//;
    $fstmplname =~ s/\s+$//;


    # warn "Rule = " . $fstmplrule;

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {

	$fstmplrule =~ s/'/''/g;

	$sth = $dbh->prepare("? = call newFileSysTmpl ( ?, ?, ?, ? );");
	
	$sth->bind_param_inout(1, \$tmplid, 10);
	$sth->bind_param(2, $fstmplname, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $fstmpltype, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fstmplrule, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $fstmpldesc, DBI::SQL_VARCHAR);
	
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newFileSysTmpl(?,?,?,?");

	$sth->bind_param(1, $fstmplname, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $fstmpltype, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $fstmplrule, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fstmpldesc, DBI::SQL_VARCHAR);
	
	$sth->execute;
	$tmplid = $sth->fetchrow_array;	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call newFileSysTmpl(?,?,?,?,?)});

	$sth->bind_param(1, $fstmplname, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $fstmpltype, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $fstmplrule, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fstmpldesc, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(5, \$tmplid, 100, DBI::SQL_INTEGER);

	$sth->execute;
	$tmplid = $sth->fetchrow_array;	
    }


    $sth->finish;    

    return sysmtFileSysTmplBase($dbh, $user, $tmplid);

}

sub sysmtFileSysTmplUpdate
{

    my ( $dbh, $user, $tmplid, $fstmplname, $fstmpltype, $fstmplrule, $fstmpldesc ) = @_;

    my $dbdata;

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	$fstmplrule =~ s/'/''/g;
    }

    $sth = $dbh->prepare("update sysmt_filesystmpl set fstmplname = ?, fstmpltype = ?, fstmplrule = ?, fstmpldesc = ? where tmplid = ?;");

    $sth->bind_param(1, $fstmplname, DBI::SQL_VARCHAR);     
    $sth->bind_param(2, $fstmpltype, DBI::SQL_VARCHAR);     
    $sth->bind_param(3, $fstmplrule, DBI::SQL_VARCHAR);     
    $sth->bind_param(4, $fstmpldesc, DBI::SQL_VARCHAR);
    $sth->bind_param(5, $tmplid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    return sysmtFileSysTmplBase($dbh, $user, $tmplid);

}

sub sysmtFileSysTmplClone
{

    my ( $dbh, $user, $tmplid, $tmplclone ) = @_;

    # reached fs tmpl retrievel
    $stmt="select fstmplname, fstmpltype, fstmpldesc, fstmplrule from sysmt_filesystmpl where tmplid = ?;";
    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);

    $sth->execute;

    my $fstmplname;
    my $fstmpltype;
    my $fstmplrule;
    my $fstmpldesc;

    ( $fstmplname, $fstmpltype, $fstmpldesc, $fstmplrule ) = $sth->fetchrow_array;     
    
    $sth->finish;

    ##### create templ clone #####

    my $dbdata;

    my $clonetmplid;

    # warn "Rule = " . $fstmplrule;

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {

	$fstmplrule =~ s/'/''/g;

	$sth = $dbh->prepare("? = call newFileSysTmpl ( ?, ?, ?, ? );");
	
	$sth->bind_param_inout(1, \$clonetmplid, 10);
	$sth->bind_param(2, $tmplclone, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $fstmpltype, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fstmplrule, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $fstmpldesc, DBI::SQL_VARCHAR);
	
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newFileSysTmpl(?,?,?,?");

	$sth->bind_param(1, $tmplclone, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $fstmpltype, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $fstmplrule, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fstmpldesc, DBI::SQL_VARCHAR);
	
	$sth->execute;
	$tmplid = $sth->fetchrow_array;	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {

	$sth = $dbh->prepare(q{call newFileSysTmpl (?,?,?,?,?)});
	
	$sth->bind_param(1, $tmplclone, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $fstmpltype, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $fstmplrule, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fstmpldesc, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(5, \$clonetmplid, 100, DBI::SQL_INTEGER);
	
	$sth->execute;

    }

    $sth->finish;    

    ## clone fs tmpl entries ##

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {

	$sth = $dbh->prepare("insert into sysmt_filesystmplentry ( tmplid, fstype, fspath, fsvg, fssizesmall, fssizebig, fsopt, fsid ) select ?, fstype, fspath, fsvg, fssizesmall, fssizebig, fsopt, nextId('FSID') from sysmt_filesystmplentry where tmplid = ?;");
	
	$sth->bind_param(1, $clonetmplid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $tmplid, DBI::SQL_INTEGER);
	
	$sth->execute;
	
	$sth->finish;    
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	# todo
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {

	my $stmt="select fstype, fspath, fsvg, fssizesmall, fssizebig, fsopt from sysmt_filesystmplentry where tmplid = ?;";
	$sth = $dbh->prepare($stmt);
	$sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);
	
	$sth->execute;
	
	my $fstype;
	my $fspath;
	my $fsvg;
	my $fsfssizesmall;
	my $fsfssizebig;
	my $fsopt;

	my @fscache;
	$i=0;
	while ( ( $fstype, $fspath, $fsvg, $fssizesmall, $fssizebig, $fsopt ) = $sth->fetchrow_array )
	{
	    # warn "Adding instance to inst cache";
	    $fscache[$i]{'fstype'} = $fstype;
	    $fscache[$i]{'fspath'} = $fspath;	
	    $fscache[$i]{'fsvg'} = $fsvg;
	    $fscache[$i]{'fssizesmall'} = $fssizesmall;
	    $fscache[$i]{'fssizebig'} = $fssizebig;
	    $fscache[$i]{'fsopt'} = $fsopt;
	    $i++;
	}
	
	$sth->finish;    
    
	foreach my $fs ( @fscache )
	{
	    my $fstype=$$fs{'fstype'};
	    my $fspath=$$inst{'fspath'};
	    my $fsvg=$$inst{'fsvg'};
	    my $fssizesmall=$$inst{'fssizesmall'};
	    my $fssizebig=$$inst{'fssizebig'};
	    my $fsopt=$$inst{'fsopt'};

	    my $fsid;
	    $sth = $dbh->prepare(q{call nextId ('FSID',?)});
	    $sth->bind_param_inout(5, \$fsid, 100, DBI::SQL_INTEGER);
	    
	    $sth->execute;
	    $fsid = $sth->fetchrow_array;	
	    	    
	    $sth = $dbh->prepare("insert into sysmt_filesystmplentry ( fsid, tmplid, fstype, fspath, fsvg, fssizesmall, fssizebig, fsopt ) values ( ?,?,?,?,?,?,?,?)");	
	    $sth->bind_param(1, $fsid, DBI::SQL_INTEGER);
	    $sth->bind_param(2, $tmplid, DBI::SQL_INTEGER);
	    $sth->bind_param(3, $fstype, DBI::SQL_VARCHAR);
	    $sth->bind_param(4, $fspath, DBI::SQL_VARCHAR);
	    $sth->bind_param(5, $fsvg, DBI::SQL_VARCHAR);
	    $sth->bind_param(6, $fssizesmall, DBI::SQL_VARCHAR);
	    $sth->bind_param(7, $fssizebig, DBI::SQL_VARCHAR);
	    $sth->bind_param(8, $fsopt, DBI::SQL_VARCHAR);
	
	    $sth->execute;
	    
	    $sth->finish;
	}
    }
    
    return sysmtFileSysTmplBase($dbh, $user, $clonetmplid);
    
}


sub sysmtFileSysTmplDelete
{

    my ( $dbh, $user, $tmplid ) = @_;

    my $dbdata;

    $sth = $dbh->prepare("delete from sysmt_filesystmplentry where tmplid = ?;");
   
    $sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    $sth = $dbh->prepare("delete from sysmt_filesystmpl where tmplid = ?;");
   
    $sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    return sysmtFileSysTmplMaster($dbh, $user);

}

sub sysmtFileSysTmplAddEntry
{

    my ( $dbh, $user, $tmplid, $fspath, $fsvg, $fslv, $fsopt, $fssizesmall, $fssizebig ) = @_;

    my $fstype = "STD";

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	my $fsid;

	$sth = $dbh->prepare("? = call newFileSysTmplEntry ( ?, ?, ?, ?, ?, ?, ?, ?);");
	
	$sth->bind_param_inout(1, \$fsid, 10);
	$sth->bind_param(2, $tmplid, DBI::SQL_INTEGER);
	$sth->bind_param(3, $fstype, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fspath, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $fsvg, DBI::SQL_VARCHAR);
	$sth->bind_param(6, $fslv, DBI::SQL_VARCHAR);
	$sth->bind_param(7, $fsopt, DBI::SQL_VARCHAR);
	$sth->bind_param(8, $fssizesmall, DBI::SQL_INTEGER);
	$sth->bind_param(9, $fssizebig, DBI::SQL_INTEGER);

	$sth->execute;
	
	$sth->finish;    

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newFileSysTmplEntry(?,?,?,?,?,?");

	$sth->bind_param(1, $fstmplname, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $fstmpldesc, DBI::SQL_VARCHAR);
	
	$sth->execute;
	$fsid = $sth->fetchrow_array;	
	$sth->finish;
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	my $fsid;

	$sth = $dbh->prepare(q{call newFileSysTmplEntry (?,?,?,?,?,?,?,?,?)});
	
	$sth->bind_param(1, $tmplid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $fstype, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $fspath, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fsvg, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $fslv, DBI::SQL_VARCHAR);
	$sth->bind_param(6, $fsopt, DBI::SQL_VARCHAR);
	$sth->bind_param(7, $fssizesmall, DBI::SQL_INTEGER);
	$sth->bind_param(8, $fssizebig, DBI::SQL_INTEGER);
	$sth->bind_param_inout(9, \$fsid, 10);

	$sth->execute;

	$sth->finish;    

    }


    return sysmtFileSysTmplFS($dbh, $user, $tmplid);

}

sub sysmtFileSysTmplUpdateEntry
{

    my ( $dbh, $user, $tmplid, $fsid, $fspath, $fsvg, $fslv, $fsopt, $fssizesmall, $fssizebig ) = @_;
    
    $sth = $dbh->prepare("update sysmt_filesystmplentry set fspath = ?, fsvg = ?, fslv = ?, fsopt = ?, fssizesmall = ?, fssizebig = ? where fsid = ?;");
    
    $sth->bind_param(1, $fspath, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $fsvg, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $fslv, DBI::SQL_VARCHAR);
    $sth->bind_param(4, $fsopt, DBI::SQL_VARCHAR);
    $sth->bind_param(5, $fssizesmall, DBI::SQL_INTEGER);
    $sth->bind_param(6, $fssizebig, DBI::SQL_INTEGER);
    $sth->bind_param(7, $fsid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    return sysmtFileSysTmplFS($dbh, $user, $tmplid);

}


sub sysmtFileSysTmplDelEntry
{

    my ( $dbh, $user, $tmplid, $fsid ) = @_;

    $sth = $dbh->prepare("delete from sysmt_filesystmplentry where fsid = ?;");

    $sth->bind_param(1, $fsid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;

    return sysmtFileSysTmplFS($dbh, $user, $tmplid);

}

1;
