#
# sysmt_gs.pm
# ------------
#
# Design and Implementation by Bjoern Lemke               
#           
# (C)opyright 2010,2011,2012 by Bjoern Lemke
#                                              
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#

package PerlSpace::SysMtGroupSearch;


sub sysmtGroupSearchMaster
{

    my ( $dbh, $user ) = @_;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_gsmaster.html";

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtGroupSearchList
{
    
    my ( $dbh, $user, $gsname) = @_;    

    my $stmt = "select gsid, gsname from sysmt_groupsearch where gsname like '%" . $gsname . "%'";    
    my $ordering = "order by gsname";
 
    sysmtGroupSearchExecuteList($dbh, $user, $stmt, $ordering);

    return 0;    

}

sub sysmtGroupSearchExecuteList
{
    
    my ( $dbh, $user, $stmt, $ordering ) = @_;

    my $sth = $dbh->prepare($stmt . " " . $ordering . ";");

    $sth->execute;
    
    my $dbdata;

    $$dbdata{'stmt'} = $stmt;

    my $mid;
    my $sid;
    my $shortdesc;    
    my $mtfrom;
    my $mtto;
    my $status;
    my $ticket;
    
    my $i=0;
    while ( ($gsid, $gsname ) = $sth->fetchrow_array) 
    {

	$$dbdata{'gslist'}[$i]{'gsid'} = $gsid;
	$$dbdata{'gslist'}[$i]{'gsname'} = $gsname;

	$i++;
    }
    
    $sth->finish;    

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_gslist.html";

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}


sub sysmtGroupSearch
{    
    my ( $dbh, $user, $gsid ) = @_;
    
    my $dbdata;

    # reached groups retrievel
    $stmt="select bgname from sysmt_bgroup bg, sysmt_gs2bgrp gs2g where gs2g.gsid = ? and gs2g.bgid = bg.bgid;";
    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $gsid, DBI::SQL_INTEGER);

    $sth->execute;
        
    my $bgroups = "";
    $$dbdata{'bgroups'} = "";
    $i=0;
    while ( ($bg) = $sth->fetchrow_array) 
    {

	$$dbdata{'delbglist'}[$i] = $bg;

	if ( $$dbdata{'bgroups'} eq "" )
	{
	    $$dbdata{'bgroups'} = $bg;
	}
	else
	{
	    $$dbdata{'bgroups'} = $$dbdata{'bgroups'} . "," . $bg;
	}
	$i++;
    }
    
    $sth->finish;    

    # retrieve adding business groups information

    $stmt="select bgname from sysmt_bgroup bg where bgid not in ( select bgid from sysmt_gs2bgrp gs2g where gs2g.gsid = ? ) order by bgname;";

    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $gsid, DBI::SQL_INTEGER);

    $sth->execute;
        
    my $sidname;	
    my $i=0;
    while ( ($group) = $sth->fetchrow_array) 
    {
	$$dbdata{'addbglist'}[$i] = $group;
	$i++;
    }
    
    $sth->finish;


    my $sth = $dbh->prepare("select gsid, gsname, gsspec from sysmt_groupsearch gs where gs.gsid = ?;");
    $sth->bind_param(1, $gsid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my $gsid;
    my $gsname;
    my $gsspec;

    ( $gsid, $gsname, $gsspec ) = $sth->fetchrow_array; 

    $$dbdata{'gsid'} = $gsid;
    $$dbdata{'gsname'} = $gsname;
    $$dbdata{'gsspec'} = $gsspec;

    $sth->fetchrow_array; 
    $sth->finish;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_gs.html";

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

    
}


sub sysmtGroupSearchNew
{

    my ( $dbh, $user ) = @_;

    my $dbdata;

    $sth = $dbh->prepare("select bgname from sysmt_bgroup;");
    
    $sth->execute;
        
    my $i=0;
    while ( ($bgname) = $sth->fetchrow_array) 
    {
	$$dbdata{'bglist'}[$i] = $bgname;
	$i++;
    }
    
    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_gsnew.html";

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}


sub sysmtGroupSearchCreate
{

    my ( $dbh, $user, $gsname, $gsspec ) = @_;

    my $dbdata;
    my $gsid;

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {

	$gsspec =~ s/'/''/g;

	$sth = $dbh->prepare("? = call newGroupSearch ( ?, ? );");
	
	$sth->bind_param_inout(1, \$gsid, 10);
	$sth->bind_param(2, $gsname, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $gsspec, DBI::SQL_VARCHAR);
	
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newGroupSearch(?,?)");

	$sth->bind_param(1, $gsname, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $gsspec, DBI::SQL_VARCHAR);
	
	$sth->execute;
	$gsid = $sth->fetchrow_array;	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call newGroupSearch(?,?,?)});

	$sth->bind_param(1, $gsname, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $gsspec, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(3, \$gsid, 100, DBI::SQL_INTEGER);

	$sth->execute;

    }


    $sth->finish;    

    return sysmtGroupSearch($dbh, $user, $gsid);

}


sub sysmtGroupSearchUpdate
{

    my ( $dbh, $user, $gsid, $gsname, $gsspec ) = @_;

    my $dbdata;

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	$gsspec =~ s/'/''/g;
    }
    
    $sth = $dbh->prepare("update sysmt_groupsearch set gsname = ?, gsspec = ? where gsid = ?;");
    
    $sth->bind_param(1, $gsname, DBI::SQL_VARCHAR);     
    $sth->bind_param(2, $gsspec, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $gsid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    return sysmtGroupSearch($dbh, $user, $gsid);

}


sub sysmtGroupSearchDelete
{

    my ( $dbh, $user, $gsid ) = @_;

    my $dbdata;

    $sth = $dbh->prepare("delete from sysmt_groupsearch where gsid = ?;");
   
    $sth->bind_param(1, $gsid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    return sysmtGroupSearchMaster($dbh, $user);

}


sub sysmtGroupSearchAdd2Grp
{

    my ( $dbh, $user, $gsid, $bgname ) = @_;
    
    $sth = $dbh->prepare("insert into sysmt_gs2bgrp values ( ?, ( select bgid from sysmt_bgroup where bgname = ? ));");
    
    $sth->bind_param(1, $gsid, DBI::SQL_INTEGER);
    $sth->bind_param(2, $bgname, DBI::SQL_VARCHAR);

    $sth->execute;

    $sth->finish;    

    return sysmtGroupSearch($dbh, $user, $gsid);

}


sub sysmtGroupSearchDelFromGrp
{

    my ( $dbh, $user, $gsid, $bgname ) = @_;

    $sth = $dbh->prepare("delete from sysmt_gs2bgrp where gsid = ? and bgid = ( select bgid from sysmt_bgroup where bgname = ? );");

    $sth->bind_param(1, $gsid, DBI::SQL_INTEGER);    
    $sth->bind_param(2, $bgname, DBI::SQL_VARCHAR);

    $sth->execute;

    $sth->finish;

    return sysmtGroupSearch($dbh, $user, $gsid);

}

1;
