#
# sysmt_host.pm
# -------------
#
# Design and Implementation by Bjoern Lemke               
#           
# (C)opyright 2010,2011,2012 by Bjoern Lemke
#                                              
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#

my $scale=2;

package PerlSpace::SysMtHost;

sub sysmtHostMaster
{

    my ( $dbh, $user ) = @_;

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_hostmaster.html', $dbdata);

    return 0;

}

sub sysmtHostListByName
{
    
    my ( $dbh, $user, $hostname ) = @_;
    my $ordering = "order by hostname";

    my $stmt = "select hid, hostname, hostinfo, osinfo, cpuinfo, meminfo from sysmt_host where hostname like '%" . $hostname ."%'";
    
    return sysmtHostExecuteList($dbh, $user, $stmt, $ordering);

}

sub sysmtHostExecuteList
{
    
    my ( $dbh, $user, $stmt, $ordering ) = @_;

    my $lastquery = $stmt; 
    my $query = $stmt . " " . $ordering. ";";

    my $sth = $dbh->prepare($query);

    # $ret = $sth->execute;
    # warn "Query is " . $lastquery;

    $sth->execute;
    
    my $dbdata;

    $$dbdata{'lastquery'} = $lastquery;
    $$dbdata{'user'} = $user;
    $$dbdata{'stmt'} = $stmt;

    my $mid;
    my $sid;
    my $shortdesc;    
    my $mtfrom;
    my $mtto;
    my $status;
    my $ticket;
    
    my $i=0;
    while ( ($hid, $hostname, $hostinfo, $osinfo, $cpuinfo, $meminfo ) = $sth->fetchrow_array) 
    {

	$$dbdata{'hostlist'}[$i]{'hid'} = $hid;
	$$dbdata{'hostlist'}[$i]{'hostname'} = $hostname;
	$$dbdata{'hostlist'}[$i]{'hostinfo'} = $hostinfo;
	$$dbdata{'hostlist'}[$i]{'osinfo'} = $osinfo;
	$$dbdata{'hostlist'}[$i]{'cpuinfo'} = $cpuinfo;
	$$dbdata{'hostlist'}[$i]{'meminfo'} = $meminfo;

	$i++;
    }
    
    $sth->finish;    

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_hostlist.html', $dbdata); 

    return 0;
}


sub sysmtHost
{
    
    my ( $dbh, $user, $hid, $stmt, $ordering ) = @_;
    
    my $dbdata;

    $$dbdata{'user'} = $user;

    my $sth = $dbh->prepare("select hid, scandate, hostname, hostinfo, osinfo, cpuinfo, meminfo from sysmt_host where hid = ?;");
    $sth->bind_param(1, $hid, DBI::SQL_INTEGER);
    
    $sth->execute;

    my $mid;
    my $lockby;
    my $project;
    my $sid;
    my $shortdesc;
    my $description;
    my $mtfrom;
    my $mtto;

    my $status;

    ( $hid, $scandate, $hostname, $hostinfo, $osinfo, $cpuinfo, $meminfo ) = $sth->fetchrow_array; 
    $sth->finish;

        
    $$dbdata{'hid'} = $hid;
    $$dbdata{'scandate'} = $scandate;
    $$dbdata{'hostname'} = $hostname;
    $$dbdata{'hostinfo'} = $hostinfo;
    $$dbdata{'cpuinfo'} = $cpuinfo;
    $$dbdata{'meminfo'} = $meminfo;


    # global zone retrievel
    $stmt="select h.hostname from sysmt_vip2host v2h, sysmt_host h where vip = ? and v2h.hid = h.hid;";

    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $hostname, DBI::SQL_VARCHAR);

    $sth->execute;

    my $set;	
    $i=0;
    while ( ($masterhost) = $sth->fetchrow_array) 
    {		
	$$dbdata{'masterlist'}[$i]{'hostname'} = $masterhost;
	$i++;
    }
    
    $sth->finish;


    # disk retrievel
    $stmt="select diskname, diskusage, disksize, diskvg from sysmt_diskview d where hostname = ? order by diskvg;";

    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $hostname, DBI::SQL_VARCHAR);
    
    $sth->execute;

    my $set;	
    $i=0;
    while ( ($diskname, $diskusage, $disksize, $diskvg) = $sth->fetchrow_array) 
    {

	$ds = sprintf("%.2f", $disksize / ( 1000 * 1024) ) . " GB";
		
	$$dbdata{'disklist'}[$i]{'diskname'} = $diskname;
	$$dbdata{'disklist'}[$i]{'diskusage'} = $diskusage;
	$$dbdata{'disklist'}[$i]{'disksize'} = $ds;
	$$dbdata{'disklist'}[$i]{'diskvg'} = $diskvg;

	$i++;
    }
    
    $sth->finish;

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_host.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
}

1;
