#
# sysmt_sys.pm
# ------------
#
# Design and Implementation by Bjoern Lemke               
#           
# (C)opyright 2010,2011,2012 by Bjoern Lemke
#                                              
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#

my $scale=4;

my $sysselection="sysid, sid, category,description,prjname,platform,mtinfo,status,scansapversion,scandbversion";

package PerlSpace::SysMtSystem;

sub sysmtSysMaster
{
    
    my ( $dbh, $user ) = @_;
    
    my $stmt;
    my $dbdata;
    
    my @rdsidlist = PerlSpace::SysMtUtil::getSysReadSidForUser($dbh, $user);
    
    $i=0;
    foreach my $sid ( @rdsidlist )
    {
	$$dbdata{'rdsidlist'}[$i] = $sid;
	$i++;
    }
    
    my @rdprjlist = PerlSpace::SysMtUtil::getSysReadProjectForUser($dbh, $user);
    
    $i=0;
    foreach my $prj ( @rdprjlist )
    {
	$$dbdata{'rdprojectlist'}[$i] = $prj;
	$i++;
    }
    
    my @wrsidlist = PerlSpace::SysMtUtil::getSysWriteSidForUser($dbh, $user);
    
    $i=0;
    foreach my $sid ( @wrsidlist )
    {
	$$dbdata{'wrsidlist'}[$i] = $sid;
	$i++;
    }
    
    my @wrprjlist = PerlSpace::SysMtUtil::getSysWriteProjectForUser($dbh, $user);
    
    $i=0;
    foreach my $prj ( @wrprjlist )
    {
	$$dbdata{'wrprojectlist'}[$i] = $prj;
	$i++;
    }
    
    @setlist = PerlSpace::SysMtUtil::getSysReadSysSetForUser($dbh, $user);
    
    $i=0;
    foreach my $set ( @setlist )
    {
	$$dbdata{'setlist'}[$i] = $set;
	$i++;
    }

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysmaster.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
    
}

sub sysmtSysBasic
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;
    
    
    
    # project retrievel
    $stmt="select prjname from sysmt_project order by prjname;";
    $sth = $dbh->prepare($stmt);
    
    $sth->execute;
    
    my $prj;	
    $i=0;
    while ( ($prj) = $sth->fetchrow_array) 
    {
	$$dbdata{'projectlist'}[$i]{'name'} = $prj;
	$i++;
    }
    
    $sth->finish;
    
    
    # sla retrievel    
    my @slalist = PerlSpace::SysMtUtil::getSLAForSysId($dbh, $sysid);
    
    $i=0;
    foreach my $sla ( @slalist )
    {
	$$dbdata{'slalist'}[$i] = $sla;
	$i++;
    }
    
    my $sth = $dbh->prepare("select sysid,\
                                    platform,\
                                    arch,\
                                    status,\
                                    prjname,\
                                    sid,\
                                    description,\
                                    category,\
                                    saptype,\
                                    sapversion,\
                                    dbtype,\
                                    dbversion,\
                                    mtinfo,\
                                    sysnr,\
                                    smdid,\
                                    vip,\
                                    vipip,\
                                    vipif,\
                                    nfsvip,\
                                    scs,\
                                    javaport,\
                                    zoneA,\
                                    zoneB,\
                                    partA,\
                                    partB,\
                                    partC,\
                                    partD,\
                                    restartzones,\
                                    sharedfs,\
                                    parthalog,\
                                    slaid,\
                                    sdbtype,\
                                    dbvip,\
                                    dbvA,\
                                    dbvB,\
                                    scandbversion,\
                                    scansapversion\
                                    from sysmt_systemview where sysid = ?;");
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my ( $sysid, 
	 $platform, 
	 $arch, 
	 $status, 
	 $project, 
	 $sid, 
	 $description, 
	 $category, 
	 $saptype, 
	 $sapversion, 
	 $dbtype, 
	 $dbversion,
	 $mtinfo, 
	 $sysnr, 
	 $smdid, 
	 $vip,
	 $vipip,
	 $vipif,
	 $nfsvip,
	 $scs,
	 $javaport,
	 $zoneA,
	 $zoneB,
	 $partA,
	 $partB,
	 $partC,
	 $partD,
	 $restartzones,
	 $sharedfs,
	 $parthalog,
	 $slaid,
	 $sdbtype,
	 $dbvip,
	 $dbvA,
	 $dbvB,
         $scandbversion,
         $scansapversion
	) = $sth->fetchrow_array; 
    
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'platform'} = $platform;
    $$dbdata{'arch'} = $arch;
    $$dbdata{'status'} = $status;
    $$dbdata{'project'} = $project;
    $$dbdata{'sid'} = $sid;
    $$dbdata{'description'} = $description;
    $$dbdata{'category'} = $category;
    $$dbdata{'saptype'} = $saptype;
    $$dbdata{'sapversion'} = $sapversion;
    $$dbdata{'dbinfo'} = $dbtype . "-" . $dbversion;
    $$dbdata{'mtinfo'} = $mtinfo;
    
    $$dbdata{'sysnr'} = $sysnr;
    $$dbdata{'smdid'} = $smdid;
    $$dbdata{'vip'} = $vip;
    $$dbdata{'vipip'} = $vipip;
    $$dbdata{'vipif'} = $vipif;
    $$dbdata{'nfsvip'} = $nfsvip;
    $$dbdata{'scs'} = $scs;
    $$dbdata{'javaport'} = $javaport;
    $$dbdata{'zoneA'} = $zoneA;
    $$dbdata{'zoneB'} = $zoneB;
    
    $$dbdata{'partA'} = $partA;
    $$dbdata{'partB'} = $partB;
    $$dbdata{'partC'} = $partC;
    $$dbdata{'partD'} = $partD;
    
    $$dbdata{'restartzones'} = $restartzones;
    $$dbdata{'sharedfs'} = $sharedfs;
    $$dbdata{'parthalog'} = $parthalog;

    $$dbdata{'sdbtype'} = $sdbtype;
    $$dbdata{'dbvip'} = $dbvip;
    $$dbdata{'dbvA'} = $dbvA;
    $$dbdata{'dbvB'} = $dbvB;
    
    $$dbdata{'scandbversion'} = $scandbversion;
    $$dbdata{'scansapversion'} = $scansapversion;
    
    $sth->fetchrow_array; 
    $sth->finish;
        
    if ( $slaid > 0 )
    {
	$$dbdata{'slanr'} = PerlSpace::SysMtUtil::getSLAForId($dbh, $slaid);
    }
    else
    {
	$$dbdata{'slanr'} = "NA";
    }
    
    # workflow retrievel
    $stmt="select bgname, status, assigned, released, dbuser, comment from sysmt_sysworkflow swf, sysmt_bgroup g where g.bgid = swf.bgid and swf.sysid = ? order by seqnr;";
    
    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my $status;	
    my $wfgroup;
    
    my $numapp = 0;
    while ( ($wfgroup, $status, $assigned, $released, $dbuser, $comment) = $sth->fetchrow_array) 
    {
	$$dbdata{'wflist'}[$numapp]{'group'} = $wfgroup;
	$$dbdata{'wflist'}[$numapp]{'status'} = $status;
	$$dbdata{'wflist'}[$numapp]{'assigned'} = $assigned;
	$$dbdata{'wflist'}[$numapp]{'released'} = $released;
	$$dbdata{'wflist'}[$numapp]{'dbuser'} = $dbuser;
	$$dbdata{'wflist'}[$numapp]{'comment'} = $comment;
	$$dbdata{'wflist'}[$numapp]{'auth'} = 'no';
	$numapp++;
    }
    
    $sth->finish;
    
    my @grouplist;
    @grouplist = PerlSpace::SysMtUtil::getGroupSetForUser($dbh, $user);
    
    foreach my $group ( @grouplist )
    {
        # warn "Checking group " . $group . "\n";
        for ( $i=0; $i<$numapp; $i++ )
        {
            if ( $$dbdata{'wflist'}[$i]{'group'} eq $group )
            {   
                # warn "Setting auth to yes\n";
                $$dbdata{'wflist'}[$i]{'auth'} = 'yes';
            }       
        }
    }

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysbasic.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSys2Set
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;
    $$dbdata{'sysid'} = $sysid;


    # reached sysset retrievel
    $stmt="select setname from sysmt_systemset ss, sysmt_sys2set s2s where ss.setid = s2s.setid and s2s.sysid = ? order by setname;";
    $sth = $dbh->prepare($stmt);
   
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;

    
    my $sysset = "";
    $$dbdata{'sidset'} = "";
    $i=0;
    while ( ($sysset) = $sth->fetchrow_array) 
    {
	$$dbdata{'delsetlist'}[$i] = $sysset;

	$$dbdata{'sidset'} = $$dbdata{'sidset'} . $sysset . "<br>";
	$i++;
    }
    
    $sth->finish;    
    
    # target sysset retrievel
    $stmt="select setname from sysmt_systemset where setid not in ( select setid from sysmt_sys2set s2s where s2s.sysid = ? ) order by setname;";
    $sth = $dbh->prepare($stmt);
   
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
 
    $sth->execute;
    
    my $sysset;	
    $i=0;
    while ( ($sysset) = $sth->fetchrow_array) 
    {
	$$dbdata{'addsetlist'}[$i] = $sysset;
	$i++;
    }
    
    $sth->finish;    

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sys2set.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
    
}


sub sysmtSysInst
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;
    
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    $$dbdata{'platform'} = PerlSpace::SysMtUtil::getPlatform($dbh, $sysid);
    
    # app retrievel
    $query="select instid, instnr, instvip, instsmd, instsaptype, instjavaport, instzone, instarch, instdisp from sysmt_instance where sysid = ? order by instnr;";
    
    $sth = $dbh->prepare($query);
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my $instid;
    my $instnr;
    my $instvip;
    my $instsmd;
    my $instsaptype;
    my $instjavaport;
    my $instzone;
    my $instarch;
    my $instdisp;
    
    
    $i=0;
    while ( ($instid, $instnr, $instvip, $instsmd, $instsaptype, $instjavaport, $instzone, $instarch, $instdisp) = $sth->fetchrow_array) 
    {
	$$dbdata{'applist'}[$i]{'instid'} = $instid;
	$$dbdata{'applist'}[$i]{'instnr'} = $instnr;
	$$dbdata{'applist'}[$i]{'instvip'} = $instvip;
	$$dbdata{'applist'}[$i]{'instsmd'} = $instsmd;
	$$dbdata{'applist'}[$i]{'instsaptype'} = $instsaptype;
	$$dbdata{'applist'}[$i]{'instjavaport'} = $instjavaport;
	$$dbdata{'applist'}[$i]{'instzone'} = $instzone;
	$$dbdata{'applist'}[$i]{'instarch'} = $instarch;
	$$dbdata{'applist'}[$i]{'instdisp'} = $instdisp;
	$i++;
    }
    
    $sth->finish;    


    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysinst.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSysDisk
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;    
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    $$dbdata{'platform'} = PerlSpace::SysMtUtil::getPlatform($dbh, $sysid);
    my $vip = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "vip");
    my $zoneA = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, 'zoneA');
    my $zoneB = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, 'zoneB');
    
    # warn "sid =" . $$dbdata{'sid'} . "\n";
    # warn "vip =" . $vip . "\n";
    # warn "zoneA =" . $zoneA . "\n";
    # warn "zoneA =" . $zoneB . "\n";
    
    my @slalist = PerlSpace::SysMtUtil::getSLAForSysId($dbh, $sysid);
    
    $i=0;
    foreach my $sla ( @slalist )
    {
	$$dbdata{'slalist'}[$i] = $sla;
	$i++;
    }
    
    # disk information retrievel
    $query="select did, diskname, diskusage, diskvg, disksize, status, ( select slanr from sysmt_sla where slaid = d.slaid ) from sysmt_disk d where status = 'valid' and ( upper(diskvg) like ? or upper(diskvg) like ? or diskvg = ? or diskvg = ? or diskvg = ? ) order by diskvg, diskname;";
    
    $sth = $dbh->prepare($query);
    $sth->bind_param(1, "VGSAP" . $$dbdata{'sid'} . "%", DBI::SQL_VARCHAR);
    $sth->bind_param(2, "VGDB" . $$dbdata{'sid'} . "%", DBI::SQL_VARCHAR);
    $sth->bind_param(3,  $zoneA . "_dg", DBI::SQL_VARCHAR);
    $sth->bind_param(4,  $zoneB . "_dg", DBI::SQL_VARCHAR);
    $sth->bind_param(5,  "vg_" . $vip , DBI::SQL_VARCHAR);
    
    $sth->execute;
    
    $i=0;
    while ( ($did, $diskname, $diskusage, $diskvg, $disksize, $status, $slanr ) = $sth->fetchrow_array) 
	
    {
	# warn "Retrieving did " . $did . "\n";
	$$dbdata{'disklist'}[$i]{'did'} = $did;
	$$dbdata{'disklist'}[$i]{'diskname'} = $diskname;
	$$dbdata{'disklist'}[$i]{'diskusage'} = $diskusage;
	$$dbdata{'disklist'}[$i]{'diskvg'} = $diskvg;
	$$dbdata{'disklist'}[$i]{'disksize'} = $disksize;
	$$dbdata{'disklist'}[$i]{'status'} = $status;
	$$dbdata{'disklist'}[$i]{'slanr'} = $slanr;
	
	$i++;
    }
    
    $sth->finish;
    

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysdisk.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSysDisp
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;    
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    $$dbdata{'category'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "category");
    
    $partA = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "partA");
    $partB = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "partB");
    $partC = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "partC");
    $partD = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "partD");
    
    # configured disp system list
    $query="select s.sid from sysmt_dispsys ds, sysmt_system s where s.sysid = ds.dispsysid and ds.sysid = ? order by s.sid;";
    $sth = $dbh->prepare($query);
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $i=0;
    my $ds;
    while ( ($ds) = $sth->fetchrow_array) 
    {
	$$dbdata{'dispsyslist'}[$i] = $ds;	
	$i++;
    }
    
    $sth->finish;    
    
    
    # disp sys retrievel
    $query="select sid from sysmt_system where category = 'catA' and ( partA = ? or partA = ? or partA = ? or partA = ? ) order by sid;";
    
    $sth = $dbh->prepare($query);
    
    $sth->bind_param(1, $partA, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $partB, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $partC, DBI::SQL_VARCHAR);
    $sth->bind_param(4, $partD, DBI::SQL_VARCHAR);
        
    $sth->execute;
    
    my $dispsys;	
    $i=0;
    while ( ($dispsys) = $sth->fetchrow_array) 
    {
	
	$$dbdata{'dispsysselect'}[$i] = $dispsys;
	$i++;
    }
    
    $sth->finish;    

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysdisp.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSysFileSys
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;    
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    
    # std fs retrievel
    $query="select fspath, fsvg, fslv, fsopt, fssize from sysmt_filesys where sysid = ? and fstype = 'STD' order by fsvg, fspath;";
    
    $sth = $dbh->prepare($query);
        
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;

    my $fspath;
    my $fsvg;
    my $fslv;
    my $fsopt;
    my $fssize;
    
    $i=0;
    while ( ( $fspath, $fsvg, $fslv, $fsopt, $fssize ) = $sth->fetchrow_array) 
    {
	
	$fspath =~ s/</&lt;/g;
	$fspath =~ s/>/&gt;/g;
	
	$fsvg =~ s/>/&gt;/g;
	$fsvg =~ s/</&lt;/g;
	
	
	$$dbdata{'stdfslist'}[$i]{'fspath'} = $fspath;
	$$dbdata{'stdfslist'}[$i]{'fsvg'} = $fsvg;
	$$dbdata{'stdfslist'}[$i]{'fslv'} = $fslv;
	$$dbdata{'stdfslist'}[$i]{'fsopt'} = $fsopt;
	$$dbdata{'stdfslist'}[$i]{'fssize'} = $fssize;
	$i++;
    }
    
    $sth->finish;    
    
    # custom fs retrievel
    $query="select fspath, fsvg, fslv, fsopt, fssize from sysmt_filesys where sysid = ? and fstype = 'CUST' order by fsvg, fspath;";
    
    $sth = $dbh->prepare($query);
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my $fspath;
    my $fsvg;
    my $fsopt;
    my $fssize;
    
    $i=0;
    while ( ( $fspath, $fsvg, $fslv, $fsopt, $fssize ) = $sth->fetchrow_array) 
    {
	
	$fspath =~ s/</&lt;/g;
	$fspath =~ s/>/&gt;/g;
	
	$fsvg =~ s/>/&gt;/g;
	$fsvg =~ s/</&lt;/g;
	
	$$dbdata{'custfslist'}[$i]{'fspath'} = $fspath;
	$$dbdata{'custfslist'}[$i]{'fsvg'} = $fsvg;
	$$dbdata{'custfslist'}[$i]{'fslv'} = $fslv;
	$$dbdata{'custfslist'}[$i]{'fsopt'} = $fsopt;
	$$dbdata{'custfslist'}[$i]{'fssize'} = $fssize;
	$i++;
    }
    
    $sth->finish;    
    

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysfs.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSysFirewall
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;    
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    
    # get server groups
    

    my @sglist = PerlSpace::SysMtUtil::getFWSGList($dbh);
    
    $i=0;
    foreach my $sg ( @sglist )
    {
	$$dbdata{'sglist'}[$i] = $sg;
	$i++;
    }

    # get port sets

    my @pslist = PerlSpace::SysMtUtil::getFWPSList($dbh);
    
    $i=0;
    foreach my $ps ( @pslist )
    {
	$$dbdata{'pslist'}[$i] = $ps;
	$i++;
    }

    # std fw retrievel
    $query="select fwrid, sgfrom, sgto, portset, fwrdesc from sysmt_sysfwview where sysid = ? order by fwrid;";
    
    $sth = $dbh->prepare($query);
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my $fwrid;
    my $sgfrom;
    my $sgto;
    my $portset;
    
    $i=0;
    while ( ( $fwrid, $sgfrom, $sgto, $portset, $fwrdesc ) = $sth->fetchrow_array) 
    {		
	$$dbdata{'stdfwlist'}[$i]{'fwrid'} = $fwrid;
	$$dbdata{'stdfwlist'}[$i]{'sgfrom'} = $sgfrom;
	$$dbdata{'stdfwlist'}[$i]{'sgto'} = $sgto;
	$$dbdata{'stdfwlist'}[$i]{'portset'} = $portset;
	$$dbdata{'stdfwlist'}[$i]{'fwrdesc'} = $fwrdesc;

	$i++;
    }
    
    $sth->finish;    

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysfw.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSysAddFirewall
{
    
    my ( $dbh,
	 $user,
	 $sysid, 
	 $sgfrom,
	 $sgto,
	 $portset,
	 $fwrdesc,
	 $stmt) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }

    $sid = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    
    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	
	$sth = $dbh->prepare("? = call newSysFW (?,?,?,?,?);");
	
	$sth->bind_param_inout(1, \$fwrid, 10);
	$sth->bind_param(2, $sgfrom, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $sgto, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $portset, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $fwrdesc, DBI::SQL_VARCHAR);
	$sth->bind_param(6, $sid, DBI::SQL_VARCHAR);
	
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newSysFW(?,?,?,?,?);");

	$sth->bind_param(1, $sgfrom, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $sgto, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $portset, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fwrdesc, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $sid, DBI::SQL_VARCHAR);
	
	$sth->execute;
	$fwrid = $sth->fetchrow_array;	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call newSysFW(?,?,?,?,?,?)});

	$sth->bind_param(1, $sgfrom, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $sgto, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $portset, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $fwrdesc, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $sid, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(6, \$fwrid, 100, DBI::SQL_INTEGER);

	$sth->execute;

    }
    
    $sth->finish;    
    
    return sysmtSysFirewall($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysUpdateFirewall
{
    
    my ( $dbh,
	 $user,
	 $fwrid,
	 $sysid,
	 $sgfrom,
	 $sgto,
	 $portset,
	 $fwrdesc,
	 $stmt) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }

    my $sth = $dbh->prepare("update sysmt_sysfw set sgidfrom = ( select sgid from sysmt_fwsg where sgname = ?), sgidto = ( select sgid from sysmt_fwsg where sgname = ? ), psid = ( select psid from sysmt_fwps where psname = ?), fwrdesc = ? where fwrid = ?;");
    
    $sth->bind_param(1, $sgfrom, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $sgto, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $portset, DBI::SQL_VARCHAR);
    $sth->bind_param(4, $fwrdesc, DBI::SQL_VARCHAR);
    $sth->bind_param(5, $fwrid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    
    
    return sysmtSysFirewall($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysDeleteFirewall
{
    
    my ( $dbh,
	 $user,
	 $sysid, 
	 $fwrid,
	 $stmt) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }

    my $sth = $dbh->prepare("delete from sysmt_sysfw where fwrid = ?;");
    
    $sth->bind_param(1, $fwrid, DBI::SQL_INTEGER);	
    
    $sth->execute;

    $sth->finish;    
    
    return sysmtSysFirewall($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysAddOn
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;    
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    
    my $sth = $dbh->prepare("select aoid,\
                                    aoname,\
                                    aotype,\
                                    aouser,\
                                    aogroup,\
                                    aohome,\
                                    aoexepath,\
                                    aologpath \
                                    from sysmt_addon where sysid = ?;");
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;

    my $i=0;
    
    while ( ( $aoid,
	      $aoname,
	      $aotype,
	      $aouser,
	      $aogroup,
	      $aohome,
	      $aoexepath,
	      $aologpath ) = $sth->fetchrow_array )
    { 
    	
	$$dbdata{'addonlist'}[$i]{'aoid'} = $aoid;
	$$dbdata{'addonlist'}[$i]{'aotype'} = $aotype;
	$$dbdata{'addonlist'}[$i]{'aoname'} = $aoname;
	$$dbdata{'addonlist'}[$i]{'aouser'} = $aouser;
	$$dbdata{'addonlist'}[$i]{'aogroup'} = $aogroup;
	$$dbdata{'addonlist'}[$i]{'aohome'} = $aohome;
	$$dbdata{'addonlist'}[$i]{'aoexepath'} = $aoexepath;
	$$dbdata{'addonlist'}[$i]{'aologpath'} = $aologpath;
	$i++;
    }
    
    $sth->finish;


    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysaddon.html";
        
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
    
}

sub sysmtSysAddAddOn
{
    
    my ( $dbh,
	 $user,
	 $sysid,	 
	 $aotype,
	 $aoname,
	 $stmt) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	
	$sth = $dbh->prepare("? = call newAddon ( ?, ?, ? );");
	
	$sth->bind_param_inout(1, \$aoid, 10);
	$sth->bind_param(2, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(3, $aotype, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $aoname, DBI::SQL_VARCHAR);
	
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newAddon(?,?,?);");
	
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $aotype, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $aoname, DBI::SQL_VARCHAR);
	
	$sth->execute;
	$sysid = $sth->fetchrow_array;	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call newAddon(?,?,?,?)});
	
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $aotype, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $aoname, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(4, \$aoid, 100, DBI::SQL_INTEGER);
	
	$sth->execute;

    }
        
    $sth->finish;    
    
    return sysmtSysAddOn($dbh, $user, $sysid, $stmt );
    
}


sub sysmtSysUpdateAddOn
{
    
    my ( $dbh,
	 $user,
	 $sysid, 	
	 $aoid,
	 $aoname,
	 $aouser,
         $aohome,
	 $aogroup,
	 $aoexepath,
	 $aologpath,
	 $stmt) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    # warn "Project is <" . $project . ">";
    
    $sth = $dbh->prepare("update sysmt_addon set aoname = ?,\
                                                  aouser = ?,\
                                                  aohome = ?,\
                                                  aogroup = ?,\
                                                  aoexepath = ?,\
                                                  aologpath = ? where aoid = ?;");

    
    
    $sth->bind_param(1, $aoname, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $aouser, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $aohome, DBI::SQL_VARCHAR);
    $sth->bind_param(4, $aogroup, DBI::SQL_VARCHAR);
    $sth->bind_param(5, $aoexepath, DBI::SQL_VARCHAR);
    $sth->bind_param(6, $aologpath, DBI::SQL_VARCHAR);
    $sth->bind_param(7, $aoid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysAddOn($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysDeleteAddOn
{
    
    my ( $dbh,
	 $user,
	 $sysid, 	 
	 $aoid,
	 $stmt) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    # warn "Project is <" . $project . ">";
    
    $sth = $dbh->prepare("delete from sysmt_addon where aoid = ?;");
    $sth->bind_param(1, $aoid, DBI::SQL_INTEGER);
    
    $sth->execute;

    $sth->finish;    
    
    return sysmtSysAddOn($dbh, $user, $sysid, $stmt );
    
}



sub sysmtSysWorkFlow
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
        
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    
    # workflow retrievel
    $query="select bgname, status, assigned, released, dbuser, comment from sysmt_sysworkflow swf, sysmt_bgroup g where g.bgid = swf.bgid and swf.sysid = ? order by seqnr;";
    
    $sth = $dbh->prepare($query);
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
        
    $sth->execute;
    
    my $status;	
    my $wfgroup;
    
    my $numapp = 0;
    while ( ($wfgroup, $status, $assigned, $released, $dbuser, $comment) = $sth->fetchrow_array) 
    {
	$$dbdata{'wflist'}[$numapp]{'group'} = $wfgroup;
	$$dbdata{'wflist'}[$numapp]{'status'} = $status;
	$$dbdata{'wflist'}[$numapp]{'assigned'} = $assigned;
	$$dbdata{'wflist'}[$numapp]{'released'} = $released;
	$$dbdata{'wflist'}[$numapp]{'dbuser'} = $dbuser;
	$$dbdata{'wflist'}[$numapp]{'comment'} = $comment;
	$$dbdata{'wflist'}[$numapp]{'auth'} = 'no';
	$numapp++;
    }
    
    $sth->finish;
    
    my @grouplist;
    @grouplist = PerlSpace::SysMtUtil::getGroupSetForUser($dbh, $user);
    
    foreach my $group ( @grouplist )
    {
        # warn "Checking group " . $group . "\n";
        for ( $i=0; $i<$numapp; $i++ )
        {
            if ( $$dbdata{'wflist'}[$i]{'group'} eq $group )
            {   
                # warn "Setting auth to yes\n";
                $$dbdata{'wflist'}[$i]{'auth'} = 'yes';
            }       
        }
    }


    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_syswf.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
}


sub sysmtSysReport
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    
    
    # std fs retrievel
    $query="select fspath, fsvg, fsopt, fssize from sysmt_filesys where sysid = ? and fstype = 'STD' order by fsvg, fspath;";
    
    $sth = $dbh->prepare($query);
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my $fspath;
    my $fsvg;
    my $fsopt;
    my $fssize;
    
    $i=0;
    while ( ( $fspath, $fsvg, $fsopt, $fssize ) = $sth->fetchrow_array) 
    {
	
	$fspath =~ s/</&lt;/g;
	$fspath =~ s/>/&gt;/g;
	
	$fsvg =~ s/>/&gt;/g;
	$fsvg =~ s/</&lt;/g;
	
	
	$$dbdata{'stdfslist'}[$i]{'fspath'} = $fspath;
	$$dbdata{'stdfslist'}[$i]{'fsvg'} = $fsvg;
	$$dbdata{'stdfslist'}[$i]{'fsopt'} = $fsopt;
	$$dbdata{'stdfslist'}[$i]{'fssize'} = $fssize;
	$i++;
    }
    
    $sth->finish;    
    
    # custom fs retrievel
    $query="select fspath, fsvg, fsopt, fssize from sysmt_filesys where sysid = ? and fstype = 'CUST' order by fsvg, fspath;";
    
    $sth = $dbh->prepare($query);
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my $fspath;
    my $fsvg;
    my $fsopt;
    my $fssize;
    
    $i=0;
    while ( ( $fspath, $fsvg, $fsopt, $fssize ) = $sth->fetchrow_array) 
    {
	
	$fspath =~ s/</&lt;/g;
	$fspath =~ s/>/&gt;/g;
	
	$fsvg =~ s/>/&gt;/g;
	$fsvg =~ s/</&lt;/g;
	
	$$dbdata{'custfslist'}[$i]{'fspath'} = $fspath;
	$$dbdata{'custfslist'}[$i]{'fsvg'} = $fsvg;
	$$dbdata{'custfslist'}[$i]{'fsopt'} = $fsopt;
	$$dbdata{'custfslist'}[$i]{'fssize'} = $fssize;
	$i++;
    }
    
    $sth->finish;    
    
    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysrep.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSysListBySid
{
    
    my ( $dbh, $user, $sid ) = @_;
    
    my $stmt = "select " . $sysselection . " from sysmt_systemview where sid = '" . $sid . "';";
    
    return sysmtSysExecuteList($dbh, $user, $stmt, 1);
    
    
}

sub sysmtSysListBySysId
{
    
    my ( $dbh, $user, $sysid ) = @_;
    
    if ( PerlSpace::SysMtUtil::checkSysRead($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    my $stmt = "select " . $sysselection . " from sysmt_systemview where sysid = " . $sysid . ";";
    
    return sysmtSysExecuteList($dbh, $user, $stmt, 1);
    
}


sub sysmtSysListByProject
{
    
    my ( $dbh, $user, $project ) = @_;
    
    
    my $stmt = "select " . $sysselection . " from sysmt_systemview where  prjname= '" . $project . "' order by sid;";
    
    return sysmtSysExecuteList($dbh, $user, $stmt, 1);
    
}

sub sysmtSysListByCategory
{
    
    my ( $dbh, $user, $category ) = @_;
    
    my $stmt = "select distinct " . $sysselection . " from sysmt_systemview sv, sysmt_prj2bgrp p2g, sysmt_usr2bgrp u2g, sysmt_bgright r, sysmt_user u where category = '" . $category . "' and sv.pid = p2g.pid and p2g.bgid = u2g.bgid and u2g.bgid = r.bgid and bgright = 'sysread' and u.dbuser = '" . $user . "' and u.uid = u2g.uid order by prjname, sid;";
    
    return sysmtSysExecuteList($dbh, $user, $stmt, 1);
    
}

sub sysmtSysListByWorkflow
{
    
    my ( $dbh, $user ) = @_;
    
    
    my $stmt = "select distinct " . $sysselection . " from sysmt_systemview sv, sysmt_sysworkflow swf, sysmt_usr2bgrp u2g, sysmt_bgright r, sysmt_user u where sv.sysid = swf.sysid and swf.status = 'Requested' and swf.bgid = u2g.bgid and u2g.bgid = r.bgid and bgright = 'sysread' and u.dbuser = '" . $user . "' and u.uid = u2g.uid order by prjname, sid;";
    
    return sysmtSysExecuteList($dbh, $user, $stmt, 1);
    
}

sub sysmtSysLookupSid
{
    
    my ( $dbh, $user, $sid ) = @_;
        
    my $stmt = "select distinct sysid, sid, prjname from sysmt_systemview where sid like ?;";

    $sth = $dbh->prepare($stmt);
    
    $sth->bind_param(1,  "%" . $sid . "%", DBI::SQL_VARCHAR);
    
    $sth->execute;

    my $dbdata;
    
    my $sysid;
    my $sid;
    my $prjname;
    
    my $i=0;
    while ( ($sysid, $sid, $prjname ) = $sth->fetchrow_array) 
    {
	$$dbdata{'syslist'}[$i]{'sysid'} = $sysid;
	$$dbdata{'syslist'}[$i]{'sid'} = $sid;
	$$dbdata{'syslist'}[$i]{'project'} = $prjname;
	$i++;
    }
    
    $sth->finish;
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_syslookup.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}



sub sysmtSysListBySysSet
{
    
    my ( $dbh, $user, $sysset ) = @_;
    
    my $stmt = "select . $sysselection .  from sysmt_systemview where sysid in ( select sysid from sysmt_systemset s, sysmt_sys2set s2s where s.setname = '" . $sysset . "' and s.setid = s2s.setid and s2s.sysid = sv.sysid ) order by prjname, sid;";
    
    return sysmtSysExecuteList($dbh, $user, $stmt, 1);
    
}

sub sysmtSysListByStatus
{
    
    my ( $dbh, $user, $status ) = @_;
    
    my $stmt = "select distinct " . $sysselection . " from sysmt_systemview sv, sysmt_prj2bgrp p2g, sysmt_usr2bgrp u2g, sysmt_bgright r, sysmt_user u where status = '" . $status . "' and sv.pid = p2g.pid and p2g.bgid = u2g.bgid and r.bgid = u2g.bgid and r.bgright = 'sysread' and u.dbuser = '" . $user . "'and u.uid = u2g.uid order by prjname, sid;";
    
    return sysmtSysExecuteList($dbh, $user, $stmt, 1);
    
}

sub sysmtSysExecuteList
{
    
    my ( $dbh, $user, $stmt, $enableEdit ) = @_;
    
    $sth = $dbh->prepare($stmt);
    
    $sth->execute;
    
    my $dbdata;
        
    $$dbdata{'stmt'} = $stmt;
    
    if ( $enableEdit )
    {
	$$dbdata{'enableEdit'} = "yes";
    }
    else
    {
	$$dbdata{'enableEdit'} = "no";
    }
    
    my $sysid;
    my $sid;
    my $description;    
    my $category;
    my $prjname;
    my $saptype;
    
    my $i=0;
    while ( ($sysid, $sid, $category, $description, $prjname, $platform, $mtinfo, $status, $sapvers, $dbvers ) = $sth->fetchrow_array) 
    {
	$$dbdata{'syslist'}[$i]{'sysid'} = $sysid;
	$$dbdata{'syslist'}[$i]{'sid'} = $sid;
	$$dbdata{'syslist'}[$i]{'description'} = $description;
	$$dbdata{'syslist'}[$i]{'category'} = $category;
	$$dbdata{'syslist'}[$i]{'project'} = $prjname;
	$$dbdata{'syslist'}[$i]{'platform'} = $platform;
	$$dbdata{'syslist'}[$i]{'mtinfo'} = $mtinfo;
	$$dbdata{'syslist'}[$i]{'status'} = $status;
	$$dbdata{'syslist'}[$i]{'sapvers'} = $sapvers;
	$$dbdata{'syslist'}[$i]{'dbvers'} = $dbvers;
	$i++;
    }
    
    $sth->finish;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_syslist.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSysNew
{
    
    my ( $dbh, $project, $category, $platform ) = @_;
    
    my $dbdata;
    
    $$dbdata{'project'} = $project;
    $$dbdata{'category'} = $category;
    $$dbdata{'platform'} = $platform;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysnew.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}


sub sysmtSysCreate
{
    
    my ( $dbh, $user, $sid, $prjname, $category, $platform, $status ) = @_;
    
    # trim left and right whitespaces
    $sid =~ s/^\s+//;
    $sid =~ s/\s+$//;
    
    my $dbdata;
    my $sysid;
    
    my $project = PerlSpace::SysMtUtil::getProjectForSid($dbh, $sid);
    
    if ( $project ne "1" && $project ne "" )
    {
        die "SID " . $sid . " already exists for project " . $project;
    }

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	
	$sth = $dbh->prepare("? = call newSystem ( ?, ?, ?, ?, ? );");
	
	$sth->bind_param_inout(1, \$sysid, 10);
	$sth->bind_param(2, $sid, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $prjname, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $category, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $platform, DBI::SQL_VARCHAR);
	$sth->bind_param(6, $status, DBI::SQL_VARCHAR);
	
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newSystem(?,?,?,?,?);");
	
	$sth->bind_param(1, $sid, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $prjname, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $category, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $platform, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $status, DBI::SQL_VARCHAR);
	
	$sth->execute;
	$sysid = $sth->fetchrow_array;	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call newSystem(?,?,?,?,?,?)});
	
	$sth->bind_param(1, $sid, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $prjname, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $category, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $platform, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $status, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(6, \$sysid, 100, DBI::SQL_INTEGER);
	
	$sth->execute;

    }
    
    
    $sth->finish;    
    
    return sysmtSysBasic($dbh, $user, $sysid );
    
}


sub sysmtSysUpdateBasic
{
    
    my ( $dbh,
	 $user,
	 $sysid, 
	 $category, 
	 $platform, 
	 $arch, 
	 $sid, 
	 $status,
	 $description, 
	 $project,
	 $saptype,
	 $sapversion,
	 $dbinfo,
	 $mtinfo,
	 $sysnr,
	 $scs,
	 $javaport,
	 $smdid,	 
	 $vip,
	 $vipip,
	 $vipif,
	 
	 $nfsvip,
	 $zoneA,
	 $zoneB,
	 $partA,
	 $partB,
	 $partC,
	 $partD,
	 $restartzones,
	 $sharedfs,
	 $parthalog,
	 $slanr,

	 $sdbtype,
	 $dbvip,
	 $dbvA,
	 $dbvB,

	 $stmt) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    # warn "Project is <" . $project . ">";

    my ( $dbtype, $dbversion ) =  split(/-/, $dbinfo);

    $sth = $dbh->prepare("update sysmt_system set category = ?,\
                                                  platform = ?,\
                                                  arch = ?,\
                                                  sid = ?,\
                                                  status = ?,\
                                                  sysdesc = ?,\
                                                  saptype = ?,\
                                                  sapversion = ?,\
                                                  dbtype = ?,\
                                                  dbversion = ?,\
                                                  mtinfo = ?,\
                                                  sysnr = ?,\
                                                  scs = ?,\
                                                  javaport = ?,\
                                                  smdid = ?,\
                                                  vip = ?,\
                                                  nfsvip = ?,\
                                                  vipip = ?,\
                                                  vipif = ?,\
                                                  zoneA = ?,\
                                                  zoneB = ?,\
                                                  partA = ?,\
                                                  partB = ?,\
                                                  partC = ?,\
                                                  partD = ?,\
                                                  restartzones = ?,\
                                                  sharedfs = ?,\
                                                  parthalog = ?,\
                                                  sdbtype = ?,\
                                                  dbvip = ?,\
                                                  dbvA = ?,\
                                                  dbvB = ?,\
                                                  slaid = ( select slaid from sysmt_sla where slanr = ? ),\
                                                  pid = ( select pid from sysmt_project where prjname = ? ) where sysid = ?;");
    
    
    my $i=1;
    
    $sth->bind_param($i, $category, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $platform, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $arch, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $sid, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $status, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $description, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $saptype, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $sapversion, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $dbtype, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $dbversion, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $mtinfo, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $sysnr, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $scs, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $javaport, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $smdid, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $vip, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $nfsvip, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $vipip, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $vipif, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $zoneA, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $zoneB, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $partA, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $partB, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $partC, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $partD, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $restartzones, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $sharedfs, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $parthalog, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $sdbtype, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $dbvip, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $dbvA, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $dbvB, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $slanr, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $project, DBI::SQL_VARCHAR);
    $i++;
    $sth->bind_param($i, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $sth->finish;    
    
    # in case of a category change, we have modify sysmt_dispsys
    
    if ( $category eq "catB" || $category eq "catC")
    {
	
	$sth = $dbh->prepare("delete from sysmt_dispsys where dispsysid = ?;");
	
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	
	$sth->execute;
	
	$sth->finish;    
	
    }
    elsif ( $category eq "CatA" )
    {
	
	$sth = $dbh->prepare("delete from sysmt_dispsys where sysid = ?;");
	
	
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	
	$sth->execute;
	
	$sth->finish;    
	
    }
    
    return sysmtSysBasic($dbh, $user, $sysid, $stmt );
    
}



sub sysmtSysDelete
{
    
    my ( $dbh, $user, $sysid ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	$sth = $dbh->prepare("call deleteSystem( ? );");
	
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	
	$sth->execute;
	
	$sth->finish;    
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select deleteSystem(?);");
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);	
	
	$sth->execute;
	$sth->finish;
	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call deleteSystem(?)});
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);	
	
	$sth->execute;
	$sth->finish;
	
    }
    
    return sysmtSysMaster($dbh, $user);
    
}

sub sysmtSysView
{
    
    my ( $dbh, $user ) = @_;
    
    my $stmt = "select distinct " . $sysselection . " from sysmt_systemview sv, sysmt_prj2bgrp p2g, sysmt_usr2bgrp u2g, sysmt_user u where sv.pid = p2g.pid and p2g.bgid = u2g.bgid and u.dbuser = '" . $user . "' and u.uid = u2g.uid order by prjname, sid;";
    
    sysmtSysExecuteList($dbh, $user, $stmt, 0);
    
    return 0;    
}

sub sysmtSysAddApp
{
    
    my ($dbh, $user, $sysid, $instnr, $instvip, $instsmd, $instsaptype, $instjavaport, $instzone, $instarch, $instdisp, $stmt ) = @_;
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	$sth = $dbh->prepare("? = call newInstance( ?, ?, ?, ?, ?, ?, ?, ?, ?);");
	
	$sth->bind_param_inout(1, \$instid, 10);	
	$sth->bind_param(2, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(3, $instnr, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $instvip, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $instsmd, DBI::SQL_VARCHAR);
	$sth->bind_param(6, $instsaptype, DBI::SQL_VARCHAR);
	$sth->bind_param(7, $instjavaport, DBI::SQL_VARCHAR);
	$sth->bind_param(8, $instzone, DBI::SQL_VARCHAR);
	$sth->bind_param(9, $instarch, DBI::SQL_VARCHAR);
	$sth->bind_param(10, $instdisp, DBI::SQL_VARCHAR);
	
	$sth->execute;
	
	$sth->finish;    
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newInstance(?, ?, ?, ?, ?, ?, ?, ?, ?);");
	
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $instnr, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $instvip, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $instsmd, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $instsaptype, DBI::SQL_VARCHAR);
	$sth->bind_param(6, $instjavaport, DBI::SQL_VARCHAR);
	$sth->bind_param(7, $instzone, DBI::SQL_VARCHAR);
	$sth->bind_param(8, $instarch, DBI::SQL_VARCHAR);
	$sth->bind_param(9, $instdisp, DBI::SQL_VARCHAR);
	
	$sth->execute;

	$instid = $sth->fetchrow_array;	
	
	$sth->finish;
	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call newInstance(?,?,?,?,?,?,?,?,?,?)});
	
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $instnr, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $instvip, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $instsmd, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $instsaptype, DBI::SQL_VARCHAR);
	$sth->bind_param(6, $instjavaport, DBI::SQL_VARCHAR);
	$sth->bind_param(7, $instzone, DBI::SQL_VARCHAR);
	$sth->bind_param(8, $instarch, DBI::SQL_VARCHAR);
	$sth->bind_param(9, $instdisp, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(10, \$instid, 10);
	
	$sth->execute;
	
	$sth->finish;    
			
    }

    return sysmtSysInst($dbh, $user, $sysid, $stmt );
}
    
sub sysmtSysUpdateApp
{
	
    my ($dbh, $user, $sysid, $instid, $instnr, $instvip, $instsmd, $instsaptype, $instjavaport, $instzone, $instarch, $instdisp, $stmt ) = @_;
        
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
	die "No appropriate right\n";
    }
   
    $sth = $dbh->prepare("update sysmt_instance set instnr = ?, instvip = ?, instsmd = ?, instsaptype = ?, instjavaport = ?, instzone = ?, instarch = ?, instdisp = ? where instid = ?;");
    
    $sth->bind_param(1, $instnr, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $instvip, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $instsmd, DBI::SQL_VARCHAR);
    $sth->bind_param(4, $instsaptype, DBI::SQL_VARCHAR);
    $sth->bind_param(5, $instjavaport, DBI::SQL_VARCHAR);
    $sth->bind_param(6, $instzone, DBI::SQL_VARCHAR);
    $sth->bind_param(7, $instarch, DBI::SQL_VARCHAR);
    $sth->bind_param(8, $instdisp, DBI::SQL_VARCHAR);
    $sth->bind_param(9, $instid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysInst($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysDelApp
{
    
    my ( $dbh, $user, $sysid, $instid, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    $sth = $dbh->prepare("delete from sysmt_instance where instid = ?;");
    
    $sth->bind_param(1, $instid, DBI::SQL_INTEGER);     
    
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysInst($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysTmpl2FS
{
    
    my ($dbh, $user, $sysid, $sizeopt, $stmt ) = @_;
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    $sid = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    $vip = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "vip");
    $smdid = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "smdid");
    $zoneA = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "zoneA");
    $zoneB = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "zoneB");
    
    $sysnr = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sysnr");
    $scs = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "scs");
    
    my @citmplidlist = PerlSpace::SysMtUtil::getCITmplForSys($dbh, $sysid);
    my @ditmplidlist = PerlSpace::SysMtUtil::getDITmplForSys($dbh, $sysid);
    
    # for testing
    # return sysmtSysFileSys($dbh, $user, $sysid, $stmt );
    
    $sth = $dbh->prepare("delete from sysmt_filesys where sysid = ? and fstype = 'STD';");
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);     
    
    $sth->execute;

    $sth->finish;
    
    foreach my $tmplid ( @citmplidlist )
    {
	
	if ( $PerlSpace::SysMtExecuter::db eq "cego" )
	{
	    
	    $sth = $dbh->prepare("insert into sysmt_filesys ( sysid, fstype, fspath, fsvg, fslv, fsopt, fssize ) select ?, fstype,\
replace(replace(replace(replace(replace(replace(replace(replace(fspath, '\@SID\@', ?), '\@VIP\@', ?), '\@SMDID\@', ?), '\@ZONEA\@', ?), '\@ZONEB\@', ?), '\@SCS\@', ?), '\@SYSNR\@', ?), '\@sid\@', lower(?)),\
replace(replace(replace(replace(replace(replace(replace(replace(fsvg,   '\@SID\@', ?), '\@VIP\@', ?), '\@SMDID\@', ?), '\@ZONEA\@', ?), '\@ZONEB\@', ?), '\@SCS\@', ?), '\@SYSNR\@', ?), '\@sid\@', lower(?)),\
replace(replace(replace(replace(replace(replace(replace(replace(fslv,   '\@SID\@', ?), '\@VIP\@', ?), '\@SMDID\@', ?), '\@ZONEA\@', ?), '\@ZONEB\@', ?), '\@SCS\@', ?), '\@SYSNR\@', ?), '\@sid\@', lower(?)),\
fsopt, fssize" . $sizeopt . " from sysmt_filesystmplentry te where te.tmplid = ?;");
	    
	    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	    
	    $sth->bind_param(2, $sid, DBI::SQL_VARCHAR);
	    $sth->bind_param(3, $vip, DBI::SQL_VARCHAR);
	    $sth->bind_param(4, $smdid, DBI::SQL_VARCHAR);
	    $sth->bind_param(5, $zoneA, DBI::SQL_VARCHAR);
	    $sth->bind_param(6, $zoneB, DBI::SQL_VARCHAR);
	    $sth->bind_param(7, $scs, DBI::SQL_VARCHAR);
	    $sth->bind_param(8, $sysnr, DBI::SQL_VARCHAR);
	    $sth->bind_param(9, $sid, DBI::SQL_VARCHAR);
	    
	    
	    $sth->bind_param(10, $sid, DBI::SQL_VARCHAR);
	    $sth->bind_param(11, $vip, DBI::SQL_VARCHAR);
	    $sth->bind_param(12, $smdid, DBI::SQL_VARCHAR);
	    $sth->bind_param(13, $zoneA, DBI::SQL_VARCHAR);
	    $sth->bind_param(14, $zoneB, DBI::SQL_VARCHAR);
	    $sth->bind_param(15, $scs, DBI::SQL_VARCHAR);
	    $sth->bind_param(16, $sysnr, DBI::SQL_VARCHAR);
	    $sth->bind_param(17, $sid, DBI::SQL_VARCHAR);
	    
	    $sth->bind_param(18, $sid, DBI::SQL_VARCHAR);
	    $sth->bind_param(19, $vip, DBI::SQL_VARCHAR);
	    $sth->bind_param(20, $smdid, DBI::SQL_VARCHAR);
	    $sth->bind_param(21, $zoneA, DBI::SQL_VARCHAR);
	    $sth->bind_param(22, $zoneB, DBI::SQL_VARCHAR);
	    $sth->bind_param(23, $scs, DBI::SQL_VARCHAR);
	    $sth->bind_param(24, $sysnr, DBI::SQL_VARCHAR);
	    $sth->bind_param(25, $sid, DBI::SQL_VARCHAR);
	    
	    $sth->bind_param(26, $tmplid, DBI::SQL_INTEGER);
	    
	    $sth->execute;
	    
	    $sth->finish;    
	}
	elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
	{
	    $sth = $dbh->prepare("select XXXXX(?, ?, ?, ?, ?, ?, ?, ?);");
	    
	    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	    $sth->bind_param(2, $instnr, DBI::SQL_VARCHAR);
	    $sth->bind_param(3, $instvip, DBI::SQL_VARCHAR);
	    $sth->bind_param(4, $instsmd, DBI::SQL_VARCHAR);
	    $sth->bind_param(5, $instsaptype, DBI::SQL_VARCHAR);
	    $sth->bind_param(6, $instjavaport, DBI::SQL_VARCHAR);
	    $sth->bind_param(7, $instzone, DBI::SQL_VARCHAR);
	    $sth->bind_param(8, $instarch, DBI::SQL_VARCHAR);
	    
	    $sth->execute;
	    $instid = $sth->fetchrow_array;	
	    
	    $sth->finish;
	    
	}
	elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
	{
	    
	    # it seems, there is a bug in the DB2-DBD-Driver. At least for complex statement liek the below,
	    # the parameter binding does not work :( . As a workaround, parameters are combined via perl concatenation
	    #
	    
	    $sth = $dbh->prepare("insert into sysmt_filesys ( sysid, fstype, fspath, fsvg, fslv, fsopt, fssize ) select $sysid, fstype,\
replace(replace(replace(replace(replace(replace(replace(replace(fspath, '\@SID\@', '$sid'), '\@VIP\@', '$vip'), '\@SMDID\@', '$smdid'), '\@ZONEA\@', '$zoneA'), '\@ZONEB\@', '$zoneB'), '\@SCS\@', '$scs'), '\@SYSNR\@', '$sysnr'), '\@sid\@', lower('$sid')),\
replace(replace(replace(replace(replace(replace(replace(replace(fsvg,   '\@SID\@', '$sid'), '\@VIP\@', '$vip'), '\@SMDID\@', '$smdid'), '\@ZONEA\@', '$zoneA'), '\@ZONEB\@', '$zoneB'), '\@SCS\@', '$scs'), '\@SYSNR\@', '$sysnr'), '\@sid\@', lower('$sid')),\
replace(replace(replace(replace(replace(replace(replace(replace(fslv,   '\@SID\@', '$sid'), '\@VIP\@', '$vip'), '\@SMDID\@', '$smdid'), '\@ZONEA\@', '$zoneA'), '\@ZONEB\@', '$zoneB'), '\@SCS\@', '$scs'), '\@SYSNR\@', '$sysnr'), '\@sid\@', lower('$sid')),\
fsopt, fssize" . $sizeopt . " from sysmt_filesystmplentry te where te.tmplid = $tmplid;");
	    
	    # $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);	   
	    # $sth->bind_param(2, $tmplid, DBI::SQL_INTEGER);
	    
	    $sth->execute;
	    
	    $sth->finish;    
	}
    }
    
    my $sth = $dbh->prepare("select instnr, instvip, instsmd, instzone from sysmt_instance where sysid = ?;");
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my @instcache;
    $i=0;
    while ( ($instnr, $instvip, $instsmd, $instzone ) = $sth->fetchrow_array) 
    {
	# warn "Adding instance to inst cache";
	$instcache[$i]{'instnr'} = $instnr;
	$instcache[$i]{'instvip'} = $instvip;	
	$instcache[$i]{'instsmd'} = $instsmd;
	$instcache[$i]{'instzone'} = $instzone;
	$i++;
    }
    
    $sth->finish;    
    
    foreach my $inst ( @instcache )
    {
	my $instnr=$$inst{'instnr'};
	my $instvip=$$inst{'instvip'};
	my $instsmd=$$inst{'instsmd'};
	my $instzone=$$inst{'instzone'};
	
	foreach my $tmplid ( @ditmplidlist )
	{
	    
	    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
	    {
		
		$sth = $dbh->prepare("insert into sysmt_filesys ( sysid, fstype, fspath, fsvg, fslv, fsopt, fssize ) select ?, fstype,\
replace(replace(replace(replace(replace(fspath, '\@SID\@', ?), '\@INSTNR\@', ?), '\@INSTVIP\@', ?), '\@INSTSMD\@', ?), '\@INSTZONE\@', ?),\
replace(replace(replace(replace(replace(fsvg,   '\@SID\@', ?), '\@INSTNR\@', ?), '\@INSTVIP\@', ?), '\@INSTSMD\@', ?), '\@INSTZONE\@', ?),\
replace(replace(replace(replace(replace(fslv,   '\@SID\@', ?), '\@INSTNR\@', ?), '\@INSTVIP\@', ?), '\@INSTSMD\@', ?), '\@INSTZONE\@', ?),\
fsopt, fssize" . $sizeopt . " from sysmt_filesystmplentry te where te.tmplid = ?;");
		
		$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
		$sth->bind_param(2, $sid, DBI::SQL_VARCHAR);
		$sth->bind_param(3, $instnr, DBI::SQL_VARCHAR);
		$sth->bind_param(4, $instvip, DBI::SQL_VARCHAR);
		$sth->bind_param(5, $instsmd, DBI::SQL_VARCHAR);
		$sth->bind_param(6, $instzone, DBI::SQL_VARCHAR);
		
		
		$sth->bind_param(7, $sid, DBI::SQL_VARCHAR);
		$sth->bind_param(8, $instnr, DBI::SQL_VARCHAR);
		$sth->bind_param(9, $instvip, DBI::SQL_VARCHAR);
		$sth->bind_param(10, $instsmd, DBI::SQL_VARCHAR);
		$sth->bind_param(11, $instzone, DBI::SQL_VARCHAR);
		
		$sth->bind_param(12, $sid, DBI::SQL_VARCHAR);
		$sth->bind_param(13, $instnr, DBI::SQL_VARCHAR);
		$sth->bind_param(14, $instvip, DBI::SQL_VARCHAR);
		$sth->bind_param(15, $instsmd, DBI::SQL_VARCHAR);
		$sth->bind_param(16, $instzone, DBI::SQL_VARCHAR);
		
		$sth->bind_param(17, $tmplid, DBI::SQL_INTEGER);
		
		$sth->execute;
		
		$sth->finish;    
		
	    }
	    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
	    {
		$sth = $dbh->prepare("select XXXXX(?, ?, ?, ?, ?, ?, ?, ?);");
		
		$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
		$sth->bind_param(2, $instnr, DBI::SQL_VARCHAR);
		$sth->bind_param(3, $instvip, DBI::SQL_VARCHAR);
		$sth->bind_param(4, $instsmd, DBI::SQL_VARCHAR);
		$sth->bind_param(5, $instsaptype, DBI::SQL_VARCHAR);
		$sth->bind_param(6, $instjavaport, DBI::SQL_VARCHAR);
		$sth->bind_param(7, $instzone, DBI::SQL_VARCHAR);
		$sth->bind_param(8, $instarch, DBI::SQL_VARCHAR);
		
		$sth->execute;
		$instid = $sth->fetchrow_array;	
		
		$sth->finish;
		
	    }
	    if ( $PerlSpace::SysMtExecuter::db eq "db2" )
	    {
		
		$sth = $dbh->prepare("insert into sysmt_filesys ( sysid, fstype, fspath, fsvg, fslv, fsopt, fssize ) select $sysid, fstype,\
replace(replace(replace(replace(replace(fspath, '\@SID\@', '$sid'), '\@INSTNR\@', '$instnr'), '\@INSTVIP\@', '$instvip'), '\@INSTSMD\@', '$instsmd'), '\@INSTZONE\@', '$instzone'),\
replace(replace(replace(replace(replace(fsvg,   '\@SID\@', '$sid'), '\@INSTNR\@', '$instnr'), '\@INSTVIP\@', '$instvip'), '\@INSTSMD\@', '$instsmd'), '\@INSTZONE\@', '$instzone'),\
replace(replace(replace(replace(replace(fslv,   '\@SID\@', '$sid'), '\@INSTNR\@', '$instnr'), '\@INSTVIP\@', '$instvip'), '\@INSTSMD\@', '$instsmd'), '\@INSTZONE\@', '$instzone'),\
fsopt, fssize" . $sizeopt . " from sysmt_filesystmplentry te where te.tmplid = $tmplid;");
		
		# $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);		
		# $sth->bind_param(2, $tmplid, DBI::SQL_INTEGER);
		
		$sth->execute;

		$sth->finish;    
		
	    }
	}
	$i++;
    }
    
    return sysmtSysFileSys($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysAddCustFileSys
{
    
    my ($dbh, $user, $sysid, $fspath, $fsvg, $fslv, $fsopt, $fssize, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    $sth = $dbh->prepare("insert into sysmt_filesys ( sysid, fstype, fspath, fsvg, fslv, fsopt, fssize) values ( ?, ?, ?, ?, ?, ?, ? );");
    
    $fstype="CUST";
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    $sth->bind_param(2, $fstype, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $fspath, DBI::SQL_VARCHAR);
    $sth->bind_param(4, $fsvg, DBI::SQL_VARCHAR);
    $sth->bind_param(5, $fslv, DBI::SQL_VARCHAR);
    $sth->bind_param(6, $fsopt, DBI::SQL_VARCHAR);
    $sth->bind_param(7, $fssize, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysFileSys($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysDelCustFileSys
{
    
    my ( $dbh, $user, $sysid, $fspath, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    $sth = $dbh->prepare("delete from sysmt_filesys where sysid = ? and fstype = 'CUST' and fspath = ?;");
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    $sth->bind_param(2, $fspath, DBI::SQL_VARCHAR);
    
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysFileSys($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysSetFileSysSize
{
    
    my ( $dbh, $user, $sysid, $fspath, $fssize, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    $sth = $dbh->prepare("update sysmt_filesys set fssize = ? where sysid = ? and fstype = 'STD' and fspath = ?;");
    
    $sth->bind_param(1, $fssize, DBI::SQL_INTEGER);
    $sth->bind_param(2, $sysid, DBI::SQL_INTEGER);
    $sth->bind_param(3, $fspath, DBI::SQL_VARCHAR);
    
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysFileSys($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysNFS
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    my $dbdata;
    
    $$dbdata{'stmt'} = $stmt;    
    $$dbdata{'sysid'} = $sysid;
    $$dbdata{'sid'} = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    
    # std nfs retrievel
    $query="select nfsid, nfspath, nfsnode, nfsmount from sysmt_nfs where sysid = ? order by nfspath, nfsnode;";
    
    $sth = $dbh->prepare($query);
        
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    my $nfsid;
    my $nfspath;
    my $nfsnode;
    my $nfsmount;
    
    $i=0;
    while ( ( $nfsid, $nfspath, $nfsnode, $nfsmount ) = $sth->fetchrow_array) 
    {
	
	$nfspath =~ s/</&lt;/g;
	$nfspath =~ s/>/&gt;/g;
		
	$$dbdata{'nfslist'}[$i]{'nfsid'} = $nfsid;
	$$dbdata{'nfslist'}[$i]{'nfspath'} = $nfspath;
	$$dbdata{'nfslist'}[$i]{'nfsnode'} = $nfsnode;
	$$dbdata{'nfslist'}[$i]{'nfsmount'} = $nfsmount;

	$i++;
    }
    
    $sth->finish;    


    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysnfs.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}

sub sysmtSysAddNFS
{
    
    my ( $dbh, $user, $sysid, $nfspath, $nfsnode, $nfsmount, $stmt ) = @_;
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right";
    }
   
    my $dbdata;

    my $nfsid;
    
    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {

	$sth = $dbh->prepare("? = call newNFS(?,?,?,?);");
	
	$sth->bind_param_inout(1, \$nfsid, 10);	
	$sth->bind_param(2, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(3, $nfspath, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $nfsnode, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $nfsmount, DBI::SQL_VARCHAR);
	
	$sth->execute;
	
	$sth->finish;    

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newNFS(?, ?, ?, ?);");

	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $nfspath, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $nfsnode, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $nfsmount, DBI::SQL_VARCHAR);
	       
	$sth->execute;
	
	$nfsid = $sth->fetchrow_array;	
	
	$sth->finish;
	
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call newNFS(?,?,?,?,?)});

	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $nfspath, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $nfsnode, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $nfsmount, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(5, \$nfsid, 10);
	
	$sth->execute;
	
	$sth->finish;    
			
    }
    
    return sysmtSysNFS($dbh, $user, $sysid, $stmt);
    
}



sub sysmtSysUpdateNFS
{
    
    my ( $dbh, $user, $sysid, $nfsid, $nfspath, $nfsnode, $nfsmount, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    $sth = $dbh->prepare("update sysmt_nfs set nfspath = ?, nfsnode = ?, nfsmount = ? where nfsid = ?;");
    
    $sth->bind_param(1, $nfspath, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $nfsnode, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $nfsmount, DBI::SQL_VARCHAR);
    $sth->bind_param(4, $nfsid, DBI::SQL_INTEGER);
   
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysNFS($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysDelNFS
{
    
    my ( $dbh, $user, $sysid, $nfsid, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
        
    $sth = $dbh->prepare("delete from sysmt_nfs where nfsid = ?;");
    
    $sth->bind_param(1, $nfsid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $sth->finish;
    
    return sysmtSysNFS($dbh, $user, $sysid, $stmt );
    
}


sub sysmtSysAddDispSys
{
    
    my ( $dbh, $user, $sysid, $dispsys, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    my $dbdata;
    
    $sth = $dbh->prepare("insert into sysmt_dispsys values ( ?, ( select sysid from sysmt_system where sid = ? and category = 'catA'));");
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    $sth->bind_param(2, $dispsys, DBI::SQL_VARCHAR);
    
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysDisp($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysDelDispSys
{
    
    my ( $dbh, $user, $sysid, $dispsys, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    my $dbdata;
    
    
    $sth = $dbh->prepare("delete from sysmt_dispsys where dispsysid = ( select sysid from sysmt_system where sid = ? and category = 'catA') and sysid = ?;");
    
    $sth->bind_param(1, $dispsys, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $sth->finish;
    
    return sysmtSysDisp($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysAddSys2Set
{
    
    my ( $dbh, $user, $sysid, $sysset, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    my $dbdata;
    
    $sth = $dbh->prepare("insert into sysmt_sys2set values ( ?, ( select setid from sysmt_systemset where setname = ? ));");
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    $sth->bind_param(2, $sysset, DBI::SQL_VARCHAR);

    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSys2Set($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysDelSysFromSet
{
    
    my ( $dbh, $user, $sysid, $sysset, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    my $dbdata;
    
    $sth = $dbh->prepare("delete from sysmt_sys2set where setid = ( select setid from sysmt_systemset where setname = ? ) and sysid = ?;");
    
    $sth->bind_param(1, $sysset, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $sth->finish;
    
    return sysmtSys2Set($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysWfFire
{
    
    my ( $dbh, $user, $sysid, $bgname, $comment ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	$sth = $dbh->prepare("? = call sysWfFire( ?, ?, ?, ? );");
	
	$sth->bind_param_inout(1, \$instid, 10);	
	$sth->bind_param(2, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(3, $bgname, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $user, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $comment, DBI::SQL_VARCHAR);
	
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	# not impl
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call sysWfFire(?,?,?,?,?)});
	
	$sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	$sth->bind_param(2, $bgname, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $user, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $comment, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(5, \$instid, 100, DBI::SQL_INTEGER);
	
	$sth->execute;

    }
    
    $sth->finish;    
    
    return sysmtSysWorkFlow($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysWfReset
{
    
    my ( $dbh, $user, $sysid, $stmt ) = @_;
    
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {
	$sth = $dbh->prepare("? = call sysWfReset( ? );");
	
	my $ret;
	$sth->bind_param_inout(1, \$ret, 10);	
	$sth->bind_param(2, $sysid, DBI::SQL_INTEGER);
	
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	## no impl
    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	## no impl
    }
    
    $sth->finish;    
    
    return sysmtSysWorkFlow($dbh, $user, $sysid, $stmt );
    
}

sub sysmtSysStat
{
    
    my ( $dbh, $user ) = @_;
    
    my $dbdata;
    
    $$dbdata{'user'} = $user;
    
    my $query="select status, count(*) from sysmt_system s where s.pid in ( select pid from sysmt_prj2bgrp where bgid in ( select bgid from sysmt_usr2bgrp u2g, sysmt_user u where u2g.uid = u.uid and u.dbuser = ? )) group by status order by status;";
    
    my $sth = $dbh->prepare($query);
    $sth->bind_param(1, $user, DBI::SQL_VARCHAR);
    
    $sth->execute;
    
    my $maxnum = 1;
    my $sysnum = 0;
    
    $i=0;
    while (($status, $sysnum) = $sth->fetchrow_array)
    {
	$$dbdata{'sysstat'}[$i]{'status'} = $status;
	$$dbdata{'sysstat'}[$i]{'sysnum'} = $sysnum;
	$i++;
	
	if ( $sysnum > $maxnum )
	{
	    $maxnum = $sysnum;
	}
    }
    
    $$dbdata{'sysentry'} = $i+1;
    
    my $j;
    for ( $j=0; $j<$i; $j++ )
    { 	
     	my $percent = (( $scale * 100 / $maxnum ) * $$dbdata{'sysstat'}[$j]{'sysnum'});
	$$dbdata{'sysstat'}[$j]{'percent'} = $percent;
    }
    
    $sth->finish;
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_sysstat.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;

}


sub sysmtSysUpdateDisk
{
    
    my ($dbh, $user, $sysid, $did, $slanr, $stmt) = @_;
    
    $sth = $dbh->prepare("update sysmt_disk set slaid = ( select slaid from sysmt_sla where slanr = ? ) where did = ?;");
    
    $sth->bind_param(1, $slanr, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $did, DBI::SQL_INTEGER);
    
    $sth->execute;
    
    $sth->finish;    
    
    return sysmtSysDisk($dbh, $user, $sysid, $stmt );
    
}

# not active
sub sysmtSysGetStdFWXXXXXXXX
{
    
    my ($dbh, $user, $sysid, $stmt ) = @_;
    
    if ( PerlSpace::SysMtUtil::checkSysWrite($dbh, $user, $sysid) == 0 )
    {
        die "No appropriate right\n";
    }
    
    $sid = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sid");
    $vip = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "vip");
    $smdid = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "smdid");
    $zoneA = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "zoneA");
    $zoneB = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "zoneB");
    
    $sysnr = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "sysnr");
    $scs = PerlSpace::SysMtUtil::getValueForSys($dbh, $sysid, "scs");

    $sidsgname =  $sid . "_SG";
    
    my @rsidlist = PerlSpace::SysMtUtil::getFWRSListForSys($dbh, $sysid);
    
    # Step 1 : clean existing rules

    $sth = $dbh->prepare("delete from sysmt_sysfw where sysid = ? and fwtype = 'std';");
    
    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
    
    $sth->execute;

    $sth->finish;

    $sth = $dbh->prepare("delete from sysmt_fwsg where sgname = ?;");
    
    $sth->bind_param(1, $sidsgname, DBI::SQL_INTEGER);
    
    $sth->execute;

    $sth->finish;
    
    my $sidsgid;

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {

	$sth = $dbh->prepare("? = call newFWSG ( ?, 'sys' );");
	
	$sth->bind_param_inout(1, \$sidsgid, 10);
	$sth->bind_param(2, $sidsgname, DBI::SQL_VARCHAR);
	
	if ( $sth->execute ne "0E0" )
	{	
	    $PerlSpace::SysMtExecuter::errmsg = $sth->errstr;
	    return 1;
	} 
    }

    foreach my $rsid ( @rsidlist )
    {

	if ( $PerlSpace::SysMtExecuter::db eq "cego" )
	{
	    
	    $sth = $dbh->prepare("insert into sysmt_sysfw ( sysid, sgidfrom, sgidto, psid, fwtype ) select ?, sgid, ?, psid, 'std' from sysmt_fwrsentry rse where rse.rsid = ? and direction = 'FROM';");
	    
	    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	    $sth->bind_param(2, $sidsgid, DBI::SQL_INTEGER);
	    $sth->bind_param(3, $rsid, DBI::SQL_INTEGER);
	    
	    $sth->execute;
	    
	    $sth->finish;    

	    $sth = $dbh->prepare("insert into sysmt_sysfw ( sysid, sgidto, sgidfrom, psid, fwtype ) select ?, sgid, ?, psid, 'std' from sysmt_fwrsentry rse where rse.rsid = ? and direction = 'TO';");
	    
	    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	    $sth->bind_param(2, $sidsgid, DBI::SQL_INTEGER);
	    $sth->bind_param(3, $rsid, DBI::SQL_INTEGER);
	    
	    $sth->execute;
	    
	    $sth->finish;    

	}
	elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
	{
	    $sth = $dbh->prepare("select XXXXX(?, ?, ?, ?, ?, ?, ?, ?);");
	    
	    $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);
	    $sth->bind_param(2, $instnr, DBI::SQL_VARCHAR);
	    $sth->bind_param(3, $instvip, DBI::SQL_VARCHAR);
	    $sth->bind_param(4, $instsmd, DBI::SQL_VARCHAR);
	    $sth->bind_param(5, $instsaptype, DBI::SQL_VARCHAR);
	    $sth->bind_param(6, $instjavaport, DBI::SQL_VARCHAR);
	    $sth->bind_param(7, $instzone, DBI::SQL_VARCHAR);
	    $sth->bind_param(8, $instarch, DBI::SQL_VARCHAR);
	    
	    $sth->execute;
	    $instid = $sth->fetchrow_array;	
	    
	    $sth->finish;
	    
	}
	elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
	{
	    
	    # it seems, there is a bug in the DB2-DBD-Driver. At least for complex statement liek the below,
	    # the parameter binding does not work :( . As a workaround, parameters are combined via perl concatenation
	    #
	    
	    $sth = $dbh->prepare("insert into sysmt_sysfw ( sysid, sgidfrom, sgidto, psid ) select $sysid, fstype,\
replace(replace(replace(replace(replace(replace(replace(replace(fspath, '\@SID\@', '$sid'), '\@VIP\@', '$vip'), '\@SMDID\@', '$smdid'), '\@ZONEA\@', '$zoneA'), '\@ZONEB\@', '$zoneB'), '\@SCS\@', '$scs'), '\@SYSNR\@', '$sysnr'), '\@sid\@', lower('$sid')),\
replace(replace(replace(replace(replace(replace(replace(replace(fsvg,   '\@SID\@', '$sid'), '\@VIP\@', '$vip'), '\@SMDID\@', '$smdid'), '\@ZONEA\@', '$zoneA'), '\@ZONEB\@', '$zoneB'), '\@SCS\@', '$scs'), '\@SYSNR\@', '$sysnr'), '\@sid\@', lower('$sid')),\
replace(replace(replace(replace(replace(replace(replace(replace(fslv,   '\@SID\@', '$sid'), '\@VIP\@', '$vip'), '\@SMDID\@', '$smdid'), '\@ZONEA\@', '$zoneA'), '\@ZONEB\@', '$zoneB'), '\@SCS\@', '$scs'), '\@SYSNR\@', '$sysnr'), '\@sid\@', lower('$sid')),\
fsopt, fssize" . $sizeopt . " from sysmt_filesystmplentry te where te.tmplid = $tmplid;");
	    
	    # $sth->bind_param(1, $sysid, DBI::SQL_INTEGER);	   
	    # $sth->bind_param(2, $tmplid, DBI::SQL_INTEGER);
	    
	    $sth->execute;
	    
	    $sth->finish;    
	}
    }
        
    return sysmtSysFireWall($dbh, $user, $sysid, $stmt );
    
}

1;
