#
# sysmt_usr.pl
# ------------
#
# Design and Implementation by Bjoern Lemke               
#           
# (C)opyright 2010, 2011, 2012 by Bjoern Lemke
#                                              
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#

package PerlSpace::SysMtUser;


sub sysmtUserMaster
{

    my ( $dbh, $user ) = @_;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_usrmaster.html";

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";

    return 0;
}

sub sysmtUsrList
{
    
    my ( $dbh, $user, $dbname) = @_;    

    my $stmt = "select uid, dbuser, username, userright, numprj, numsys from sysmt_usrview where dbuser like '%" . $dbname . "%'";    
    my $ordering = "order by dbuser";
 
    return sysmtUsrExecuteList($dbh, $user, $stmt, $ordering);

}

sub sysmtUsrListByGroup
{
    
    my ( $dbh, $user, $bgname) = @_;    

    my $stmt = "select uid, dbuser, username, userright, numprj, numsys from sysmt_usrview uv where uid in ( select u.uid from sysmt_user u, sysmt_usr2bgrp u2g, sysmt_bgroup g where u.uid = u2g.uid and u2g.bgid = g.bgid and bgname = '" . $bgname . "')";
    my $ordering = "order by dbuser";
 
    return sysmtUsrExecuteList($dbh, $user, $stmt, $ordering);

}


sub sysmtUsrExecuteList
{
    
    my ( $dbh, $user, $stmt, $ordering ) = @_;

    my $sth = $dbh->prepare($stmt . " " . $ordering . ";");

    $sth->execute;
    
    my $dbdata;

    $$dbdata{'stmt'} = $stmt;
    
    my $i=0;
    while ( ($uid, $logname, $username, $userright, $numprj, $numsys ) = $sth->fetchrow_array) 
    {
	$$dbdata{'usrlist'}[$i]{'uid'} = $uid;
	$$dbdata{'usrlist'}[$i]{'logname'} = $logname;
	$$dbdata{'usrlist'}[$i]{'username'} = $username;
	$$dbdata{'usrlist'}[$i]{'userright'} = $userright;
	$$dbdata{'usrlist'}[$i]{'numprj'} = $numprj;
	$$dbdata{'usrlist'}[$i]{'numsys'} = $numsys;
	$i++;
    }
    
    $sth->finish;    

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_usrlist.html";
    
    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    return 0;
}


sub sysmtUsr
{
    
    my ( $dbh, $user, $uid ) = @_;

    my $dbdata;

    # reached groups retrievel
    $stmt="select bgname from sysmt_bgroup bg, sysmt_usr2bgrp u2g where u2g.uid = ? and u2g.bgid = bg.bgid;";
    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $uid, DBI::SQL_INTEGER);

    
    $sth->execute;
        
    my $bgroups = "";
    $$dbdata{'bgroups'} = "";
    $i=0;
    while ( ($bg) = $sth->fetchrow_array) 
    {

	$$dbdata{'delbglist'}[$i] = $bg;

	if ( $$dbdata{'bgroups'} eq "" )
	{
	    $$dbdata{'bgroups'} = $bg;
	}
	else
	{
	    $$dbdata{'bgroups'} = $$dbdata{'bgroups'} . ", " . $bg;
	}
	$i++;
    }
    
    $sth->finish;    


    my $sth = $dbh->prepare("select uid, dbuser, username, userdesc, userright, usermail from sysmt_user where uid = ?;");
    $sth->bind_param(1, $uid, DBI::SQL_INTEGER);
    
    $sth->execute;
    

    my $uid;
    my $logname;
    my $username;
    my $userdesc;
    my $userright;


    ( $uid, $logname, $username, $userdesc, $userright, $usermail ) = $sth->fetchrow_array; 

    $$dbdata{'uid'} = $uid;
    $$dbdata{'logname'} = $logname;
    $$dbdata{'username'} = $username;
    $$dbdata{'userdesc'} = $userdesc;
    $$dbdata{'userright'} = $userright;
    $$dbdata{'usermail'} = $usermail;
    
    $sth->fetchrow_array; 
    $sth->finish;

    # retrieve adding business groups information

    $stmt="select bgname from sysmt_bgroup bg where bgid not in ( select bgid from sysmt_usr2bgrp u2g where u2g.uid = ? ) order by bgname;";

    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $uid, DBI::SQL_INTEGER);

    $sth->execute;
        
    my $sidname;	
    my $i=0;
    while ( ($group) = $sth->fetchrow_array) 
    {
	$$dbdata{'addbglist'}[$i] = $group;
	$i++;
    }
    
    $sth->finish;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_usr.html";

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
}


sub sysmtUsrNew
{

    my ( $dbh, $user ) = @_;

    my $dbdata;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = "sysmt_usrnew.html";

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";
    
    return 0;
}

sub sysmtUsrCreate
{

    my ( $dbh, $user, $logname, $username, $userdesc, $userright, $usermail ) = @_;

    # trim left and right whitespaces
    $logname =~ s/^\s+//;
    $logname =~ s/\s+$//;

    my $dbdata;
    my $uid;

    if ( $PerlSpace::SysMtExecuter::db eq "cego" )
    {

	$sth = $dbh->prepare("? = call newUser ( ?, ?, ?, ?, ? );");
	    
    
	$sth->bind_param_inout(1, \$uid, 10);
	$sth->bind_param(2, $logname, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $username, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $userdesc, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $userright, DBI::SQL_VARCHAR);
	$sth->bind_param(6, $usermail, DBI::SQL_VARCHAR);
    
	$sth->execute;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "mysql" )
    {
	$sth = $dbh->prepare("select newUser(?,?, ?, ?, ?);");

	$sth->bind_param(1, $logname, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $username, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $userdesc, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $userright, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $usermail, DBI::SQL_VARCHAR);
	$sth->execute;
	$uid = $sth->fetchrow_array;

    }
    elsif ( $PerlSpace::SysMtExecuter::db eq "db2" )
    {
	$sth = $dbh->prepare(q{call newUser ( ?, ?, ?, ?, ?, ?)});

	$sth->bind_param(1, $logname, DBI::SQL_VARCHAR);
	$sth->bind_param(2, $username, DBI::SQL_VARCHAR);
	$sth->bind_param(3, $userdesc, DBI::SQL_VARCHAR);
	$sth->bind_param(4, $userright, DBI::SQL_VARCHAR);
	$sth->bind_param(5, $usermail, DBI::SQL_VARCHAR);
	$sth->bind_param_inout(6, \$uid, 10);

	$sth->execute;

    }

    $sth->finish;    


    return sysmtUsr($dbh, $user, $uid);

}

sub sysmtUsrUpdate
{

    my ( $dbh, $user, $uid, $logname, $username, $userdesc, $userright, $usermail ) = @_;


    $oldlogname = PerlSpace::SysMtUtil::getUserName($dbh, $uid);

    # if logname changes, we remove the old logname from passwd
    if ( $logname ne $oldlogname )
    {
	
	$cmd = $PerlSpace::SysMtExecuter::htpasswdpath . " -D " . $PerlSpace::SysMtExecuter::passwdfile . " " . $oldlogname;
	$res = system $cmd;
	
    }
        
    $sth = $dbh->prepare("update sysmt_user set dbuser = ?, username = ?, userdesc = ?, userright = ?, usermail = ?  where uid = ?;");
     
    $sth->bind_param(1, $logname, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $username, DBI::SQL_VARCHAR);
    $sth->bind_param(3, $userdesc, DBI::SQL_VARCHAR);
    $sth->bind_param(4, $userright, DBI::SQL_VARCHAR);
    $sth->bind_param(5, $usermail, DBI::SQL_VARCHAR);

    $sth->bind_param(6, $uid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    return sysmtUsr($dbh, $user, $uid);

}

sub sysmtUsrDelete
{

    my ( $dbh, $user, $uid ) = @_;

    my $dbdata;

    $sth = $dbh->prepare("delete from sysmt_usr2bgrp where uid = ?;");    
    $sth->bind_param(1, $uid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    $logname = PerlSpace::SysMtUtil::getUserName($dbh, $uid);

    $sth = $dbh->prepare("delete from sysmt_user where uid = ?;");   
    $sth->bind_param(1, $uid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;    

    # Deleting user from passwd file


    $cmd = $PerlSpace::SysMtExecuter::htpasswdpath . " -D " . $PerlSpace::SysMtExecuter::passwdfile . " " . $logname;

   
    $res = system $cmd;
    
    # warn "Command finished .."; 

    my $msg;
    if ( $res == 0 )
    {
	$msg = "User " . $logname . " deleted"
    }
    else
    {
	$msg = "Cannot delete user " . $logname;
    }

    # warn $msg;

    # warn "Command finished .."; 


    return sysmtUsrList($dbh, $user, "");

}


sub sysmtUsrAdd2Grp
{

    my ( $dbh, $user, $uid, $bgname ) = @_;

    my $dbdata;
    
    $sth = $dbh->prepare("insert into sysmt_usr2bgrp values ( ?, ( select bgid from sysmt_bgroup where bgname = ? ));");
    
    $sth->bind_param(1, $uid, DBI::SQL_INTEGER);
    $sth->bind_param(2, $bgname, DBI::SQL_VARCHAR);
    
    $sth->execute;

    $sth->finish;    

    return sysmtUsr($dbh, $user, $uid);

}


sub sysmtUsrDelFromGrp
{

    my ( $dbh, $user, $uid, $bgname ) = @_;

    my $dbdata;

    
    $sth = $dbh->prepare("delete from sysmt_usr2bgrp where bgid = ( select bgid from sysmt_bgroup where bgname = ? ) and uid = ?;");
    
    $sth->bind_param(1, $bgname, DBI::SQL_VARCHAR);
    $sth->bind_param(2, $uid, DBI::SQL_INTEGER);

    $sth->execute;

    $sth->finish;

    return sysmtUsr($dbh, $user, $uid);

}

sub sysmtUsrSetPwd
{

    my ( $dbh, $user, $uid, $logname, $pwd ) = @_;

    $cmd = $PerlSpace::SysMtExecuter::htpasswdpath . " -b " . $PerlSpace::SysMtExecuter::passwdfile . " " . $logname . " " . $pwd;

    # warn $cmd ;

    $res = system $cmd;
    
    # warn "Command finished .."; 

    my $msg;
    if ( $res == 0 )
    {
	$msg = "Password set"
    }
    else
    {
	$msg = "Cannot set up password";
    }
    # warn "Command finished .."; 

    return sysmtUsr($dbh, $user, $uid);

}

sub sysmtUsrPwdByUser
{

    my ( $dbh, $user, $pwd ) = @_;

    $cmd = $PerlSpace::SysMtExecuter::htpasswdpath . " -b " . $PerlSpace::SysMtExecuter::passwdfile . " " . $user . " " . $pwd;

    # warn $cmd ;

    $res = system $cmd;

    my $msg;
    if ( $res == 0 )
    {
        $msg = "Password set"
    }
    else
    {
        $msg = "Cannot set up password";
    }
    # warn "Command finished ..";
    return sysmtUsrInfo($dbh, $user, $msg);

}

sub sysmtUsrInfo
{

    my ( $dbh, $user, $msg ) = @_;

    my $dbdata;

    # reached groups retrievel
    $stmt="select bgname from sysmt_bgroup bg, sysmt_usr2bgrp u2g, sysmt_user u where u2g.uid = u.uid and u2g.bgid = bg.bgid and u.dbuser = ?;";
    $sth = $dbh->prepare($stmt);
    $sth->bind_param(1, $user, DBI::SQL_VARCHAR);

    $sth->execute;

    my $bgroups = "";
    $$dbdata{'bgroups'} = "";
    $i=0;
    while ( ($bg) = $sth->fetchrow_array)
    {
        if ( $$dbdata{'bgroups'} eq "" )
        {
            $$dbdata{'bgroups'} = $bg;
        }
        else
        {
            $$dbdata{'bgroups'} = $$dbdata{'bgroups'} . "," . $bg;
        }
        $i++;
    }

    $sth->finish;


    my $sth = $dbh->prepare("select uid, dbuser, username, userright, userdesc, usermail from sysmt_user where dbuser = ?;");
    $sth->bind_param(1, $user, DBI::SQL_VARCHAR);

    $sth->execute;


    my $uid;
    my $logname;
    my $username;
    my $userdesc;
    my $usermail;

    ( $uid, $logname, $username, $userright, $userdesc, $usermail ) = $sth->fetchrow_array;

    $$dbdata{'uid'} = $uid;
    $$dbdata{'logname'} = $logname;
    $$dbdata{'username'} = $username;
    $$dbdata{'userdesc'} = $userdesc;
    $$dbdata{'userright'} = $userright;
    $$dbdata{'usermail'} = $usermail;
    $$dbdata{'msg'} = $msg;

    $sth->fetchrow_array;
    $sth->finish;


    $sth = $dbh->prepare("select bgname from sysmt_bgroup;");

    $sth->execute;

    my $sidname;
    my $i=0;
    while ( ($group) = $sth->fetchrow_array)
    {
        $$dbdata{'bglist'}[$i] = $group;
        $i++;
    }

    $sth->finish;

    my ( $headmsg, $fullname, $sysmsg )  = PerlSpace::SysMtUtil::getHeaderInfo($dbh, $user);
    $$dbdata{'headertext'} = $headmsg;
    $$dbdata{'fullname'} = $fullname;
    $$dbdata{'sysmsg'} = $sysmsg;
    $$dbdata{'content'} = 'sysmt_usrinfo.html';

    $TT ||= Template->new({ INCLUDE_PATH  => $PerlSpace::SysMtExecuter::tmplpath });
    $TT->process('sysmt_frame.html', $dbdata) || die $TT->error(), "\n";

    return 0;

}

1;
