#!/usr/local/bin/perl
use DBI;
use DBD::Cego;
use POSIX qw/strftime/;

$mode;
$counter=0;

while(@ARGV)
{
    if ( $counter == 0 )
    {
	$mode=shift;
    }
    $counter++;
};


# db connection parameter
$dbhost="localhost";
$dbport="2200";
$tableset="sysmt";
$user="sysmt";
$pwd="sysmt";
# other 
$dayahead=90;

my $notifyref;

$mailto= 'lemke@lemke-it.com';

$ts = strftime('%d.%m.%Y %H:%M:%S',localtime);
 
my $dbh = DBI->connect("dbi:Cego:tableset=$tableset;hostname=$dbhost;port=$dbport", "$user", "$pwd");

# $dbh->do("set append off;");

my $sth = $dbh->prepare("select mv.mid, mv.prjname, mv.sid, mv.shortdesc, mv.mtfrom, mv.mtto, mv.status, mv.ticketnr \
from sysmt_mtview mv \
where mv.mtfrom > date('%d.%m.%Y %H:%M:%S', ?) and int2date(date2int(mv.mtfrom) - 60*60*24*$dayahead) < date('%d.%m.%Y %H:%M:%S', ?) \
order by mv.mtfrom;");

$sth->bind_param(1, $ts, DBI::SQL_VARCHAR);
$sth->bind_param(2, $ts, DBI::SQL_VARCHAR);

$sth->execute;

open(MAIL, "| /bin/mailx -s \"SysMT Forecast\" $mailto ") || die "mailx failed: $!\n";

while (($mid, $prjname, $sid, $shortdesc, $mtfrom, $mtto, $status, $ticketnr ) = $sth->fetchrow_array) 
{
    # print MAIL "$mid" . "," . $sid . "," . $status . "\n";
    print MAIL "$mid" . "," 
	. $prjname . "," 
	. $sid . "," 
	. $shortdesc . "," 
	. $mtfrom . "," 
	. $mtto . "," 
	. $status . "," 
	. $ticketnr 
	. "\n";
}

close MAIL;

# $dbh->{AutoCommit} = 1;
$dbh->disconnect;

