drop if exists table sysmt_threadgroup;
drop if exists table sysmt_systemset;
drop if exists table sysmt_filesystmplentry;
drop if exists table sysmt_prj2notification;
drop if exists table sysmt_fwsg;
drop if exists table sysmt_fwpsentry;
drop if exists table sysmt_gs2bgrp;
drop if exists table sysmt_sla;
drop if exists table sysmt_vip2host;
drop if exists table sysmt_prj2approval;
drop if exists table sysmt_tg2bgrp;
drop if exists table sysmt_mtlog;
drop if exists table sysmt_disk;
drop if exists table sysmt_fwrsentry;
drop if exists table sysmt_addon;
drop if exists table sysmt_disk2host;
drop if exists table sysmt_bgright;
drop if exists table sysmt_mtverification;
drop if exists table sysmt_document;
drop if exists table sysmt_threadlog;
drop if exists table sysmt_project;
drop if exists table sysmt_id;
drop if exists table sysmt_bgroup;
drop if exists table sysmt_host;
drop if exists table sysmt_fwsgentry;
drop if exists table sysmt_usersearch;
drop if exists table sysmt_custcond;
drop if exists table sysmt_filesystmpl;
drop if exists table sysmt_user;
drop if exists table sysmt_sysworkflow;
drop if exists table sysmt_nfs;
drop if exists table sysmt_sla2prj;
drop if exists table sysmt_usr2bgrp;
drop if exists table sysmt_prj2workflow;
drop if exists table sysmt_instance;
drop if exists table sysmt_fwps;
drop if exists table sysmt_sys2set;
drop if exists table sysmt_set2bgrp;
drop if exists table sysmt_mtapproval;
drop if exists table sysmt_prj2bgrp;
drop if exists table sysmt_prj2verification;
drop if exists table sysmt_mt;
drop if exists table sysmt_thr2bgrp;
drop if exists table sysmt_filesys;
drop if exists table sysmt_system;
drop if exists table sysmt_doc2thread;
drop if exists table sysmt_sysfw;
drop if exists table sysmt_groupsearch;
drop if exists table sysmt_thread;
drop if exists table sysmt_dispsys;

create table sysmt_threadgroup(tgid int not null, tgname string(30), tgdesc string(500));
create table sysmt_systemset(setid int not null, setname string(20), description string(1000));
create table sysmt_filesystmplentry(tmplid int not null, fstype string(50), fspath string(100) not null, fsvg string(100) not null, fssizesmall long not null, fsopt string(100), fsid int, fssizebig long, fslv string(100));
create table sysmt_prj2notification(pid int not null, bgid int not null);
create table sysmt_fwsg(sgid int not null, sgname string(30), sgdesc string(500), sgtype string(10));
create table sysmt_fwpsentry(psid int, portval string(30), portdesc string(500));
create table sysmt_gs2bgrp(gsid int not null, bgid int not null);
create table sysmt_sla(slaid int not null, slanr string(30), shortdesc string(100));
create table sysmt_vip2host(vip string(30) not null, hid int not null, status string(15));
create table sysmt_prj2approval(pid int not null, bgid int not null);
create table sysmt_tg2bgrp(tgid int not null, bgid int not null);
create table sysmt_mtlog(logts datetime, mid int, logentry string(100));
create table sysmt_disk(did int not null, scandate datetime, status string(20), diskname string(100), disksize long, diskusage string(100), diskvg string(100), slaid int);
create table sysmt_fwrsentry(rsid int, sgid int, psid int, ruledesc string(500), direction string(10));
create table sysmt_addon(aoid int not null, aotype string(20), aoname string(20), aohome string(100), aouser string(100), aogroup string(100), aoexepath string(100), aologpath string(100), sysid int);
create table sysmt_disk2host(did int not null, hid int not null);
create table sysmt_bgright(bgid int not null, bgright string(20) not null);
create table sysmt_mtverification(mid int not null, bgid int not null, status string(10));
create table sysmt_document(docid int not null, doctype string(10), docname string(200));
create table sysmt_threadlog(logts datetime, logentry string(1000), thrid int, dbuser string(20));
create table sysmt_project(pid int not null, prjname string(100), prjdesc string(1000), prjmail string(100));
create table sysmt_id(id string(10) not null, idval int);
create table sysmt_bgroup(bgid int not null, bgname string(20), bgdesc string(10000));
create table sysmt_host(hid int not null, scandate datetime, status string(20), hostname string(30), hostinfo string(100), osinfo string(30), cpuinfo string(30), meminfo string(30));
create table sysmt_fwsgentry(sgid int, ipval string(30), ipdesc string(500));
create table sysmt_usersearch(usid int not null, usname string(20), usspec string(1000), uid int);
create table sysmt_custcond(ccid int not null, ccname string(20), ccspec string(100), uid int, cctype string(20));
create table sysmt_filesystmpl(tmplid int not null, fstmplname string(50), fstmpldesc string(500), fstmplrule string(200), fstmpltype string(10));
create table sysmt_user(uid int not null, dbuser string(20), username string(20), userdesc string(1000), userright string(10), usermail string(100));
create table sysmt_sysworkflow(sysid int not null, bgid int not null, seqnr int, assigned datetime, released datetime, dbuser string(20), comment string(500), status string(10));
create table sysmt_nfs(nfsid int not null, nfspath string(100), nfsnode string(100), nfsmount string(100), sysid int);
create table sysmt_sla2prj(slaid int not null, pid int not null);
create table sysmt_usr2bgrp(uid int not null, bgid int not null);
create table sysmt_prj2workflow(pid int not null, bgid int not null, seqnr int);
create table sysmt_instance(instid int not null, instnr string(10) not null, instvip string(50) not null, instsmd string(10) not null, instzone string(50), instarch string(10), sysid int not null, created datetime default date('%d.%m.%Y %H:%M:%S','01.04.2011 08:35:21') not null, instsaptype string(10), instjavaport string(10), instdisp string(10));
create table sysmt_sys2set(sysid int not null, setid int not null);
create table sysmt_fwps(psid int not null, psname string(30), psdesc string(500));
create table sysmt_set2bgrp(setid int not null, bgid int not null);
create table sysmt_mtapproval(mid int not null, bgid int not null, status string(10));
create table sysmt_prj2bgrp(pid int not null, bgid int not null);
create table sysmt_prj2verification(pid int not null, bgid int not null);
create table sysmt_mt(mid int not null, shortdesc string(100), description string(500), mtfrom datetime, mtto datetime, status string(10), ticketnr bigint(10), sysid int, lockby string(20), mttype string(10), downfrom datetime, downto datetime, repcomment string(50), repappcheck string(10), thrid int);
create table sysmt_thr2bgrp(thrid int not null, bgid int not null);
create table sysmt_filesys(fstype string(50), fspath string(100) not null, fsvg string(100) not null, fssize long not null, sysid int not null, fsopt string(100), fslv string(100));
create table sysmt_system(sysid int not null, sid string(20), category string(10), sysdesc string(1000), pid int, systype string(10), mtinfo string(300), platform string(10), status string(10), saptype string(10), vip string(20), sysnr string(10), scs string(10), javaport string(10), smdid string(10), zoneA string(20), zoneB string(20), partA string(20), partB string(20), partC string(20), partD string(20), restartzones string(100), created datetime default date('%d.%m.%Y %H:%M:%S','01.04.2011 08:35:23'), dbtype string(10), arch string(10), nfsvip string(30), vipip string(20), vipif string(20), dbversion string(20), sharedfs string(300), parthalog string(300), slaid int, sapversion string(20), sdbtype string(10), dbvip string(20), dbvA string(20), dbvB string(20));
create table sysmt_doc2thread(docid int, thrid int);
create table sysmt_sysfw(fwrid int not null, sgidfrom int, sgidto int, psid int, sysid int);
create table sysmt_groupsearch(gsid int not null, gsname string(20), gsspec string(100));
create table sysmt_thread(thrid int not null, shortdesc string(100), description string(1000), created datetime, remind datetime, status string(15), tgid int, bgid int);
create table sysmt_dispsys(sysid int not null, dispsysid int not null);



drop if exists index sysmt_threadgroup_pidx;
create primary index  on sysmt_threadgroup(tgid);
drop if exists index sysmt_prj2notification_pidx;
create primary index  on sysmt_prj2notification(pid,bgid);
drop if exists index sysmt_fwsg_pidx;
create primary index  on sysmt_fwsg(sgid);
drop if exists index sysmt_systemset_pidx;
create primary index  on sysmt_systemset(setid);
drop if exists index sysmt_sla_pidx;
create primary index  on sysmt_sla(slaid);
drop if exists index sysmt_tg2bgrp_pidx;
create primary index  on sysmt_tg2bgrp(tgid,bgid);
drop if exists index sysmt_disk_pidx;
create primary index  on sysmt_disk(did);
drop if exists index sysmt_addon_pidx;
create primary index  on sysmt_addon(aoid);
drop if exists index sysmt_document_pidx;
create primary index  on sysmt_document(docid);
drop if exists index sysmt_project_pidx;
create primary index  on sysmt_project(pid);
drop if exists index sysmt_project_i1;
create unique index sysmt_project_i1 on sysmt_project(prjname);
drop if exists index sysmt_bgroup_pidx;
create primary index  on sysmt_bgroup(bgid);
drop if exists index sysmt_bgroup_i1;
create index sysmt_bgroup_i1 on sysmt_bgroup(bgname);
drop if exists index sysmt_user_pidx;
create primary index  on sysmt_user(uid);
drop if exists index sysmt_user_i1;
create unique index sysmt_user_i1 on sysmt_user(dbuser);
drop if exists index sysmt_instance_pidx;
create primary index  on sysmt_instance(instid);
drop if exists index sysmt_fwps_pidx;
create primary index  on sysmt_fwps(psid);
drop if exists index sysmt_usr2bgrp_pidx;
create primary index  on sysmt_usr2bgrp(uid,bgid);
drop if exists index sysmt_usr2bgrp_i1;
create index sysmt_usr2bgrp_i1 on sysmt_usr2bgrp(bgid);
drop if exists index sysmt_prj2bgrp_pidx;
create primary index  on sysmt_prj2bgrp(pid,bgid);
drop if exists index sysmt_prj2bgrp_i1;
create index sysmt_prj2bgrp_i1 on sysmt_prj2bgrp(bgid);
drop if exists index sysmt_prj2bgrp_i2;
create index sysmt_prj2bgrp_i2 on sysmt_prj2bgrp(pid);
drop if exists index sysmt_mt_i1;
create index sysmt_mt_i1 on sysmt_mt(status);
drop if exists index sysmt_mt_i2;
create index sysmt_mt_i2 on sysmt_mt(mtfrom);
drop if exists index sysmt_mt_i3;
create index sysmt_mt_i3 on sysmt_mt(sysid);
drop if exists index sysmt_mt_pidx;
create primary index  on sysmt_mt(mid);
drop if exists index sysmt_mt_i4;
create index sysmt_mt_i4 on sysmt_mt(mtto);
drop if exists index sysmt_thread_pidx;
create primary index  on sysmt_thread(thrid);
drop if exists index sysmt_thread_i1;
create index sysmt_thread_i1 on sysmt_thread(tgid);
drop if exists index sysmt_system_pidx;
create primary index  on sysmt_system(sysid);
drop if exists index sysmt_system_i1;
create index sysmt_system_i1 on sysmt_system(pid);
drop if exists index sysmt_sysfw_pidx;
create primary index  on sysmt_sysfw(fwrid);

-------------
--- Views ---
-------------

drop if exists view sysmt_mtview;
create view sysmt_mtview as
select
 mt.mid as mid,
 mt.lockby as lockby,
 prj.prjname as prjname,
 prj.pid as pid,
 sys.sysid as sysid,
 sys.sid as sid,
 sys.category as category,
 sys.saptype as saptype,
 sys.mtinfo as mtinfo,
 mt.shortdesc as shortdesc,
 mt.description as description,
 mt.mtfrom as mtfrom,
 mt.mtto as mtto,
 mt.downfrom as downfrom,
 mt.downto as downto,
 mt.status as status,
 mt.ticketnr as ticketnr,
 mt.mttype as mttype,
 mt.repcomment as repcomment,
 mt.repappcheck as repappcheck,
 mt.thrid as thrid,
 (select
 tg.tgname as tgname
from
 sysmt_threadgroup@sysmt tg,
 sysmt_thread@sysmt t
where
 ( t.thrid = mt.thrid
  and
 t.tgid = tg.tgid )
) as tgname,
 (select
 t.shortdesc as shortdesc
from
 sysmt_thread@sysmt t
where
 t.thrid = mt.thrid
) as tshortdesc,
 (select
 count(*)
from
 sysmt_mt@sysmt mt2
where
 ( ( ( mt2.mtfrom > mt.mtfrom
 and
mt2.mtfrom < mt.mtto )
 and
mt2.mid != mt.mid )
  and
 mt.sysid = mt2.sysid )
) as conflicts
from
 sysmt_mt@sysmt mt,
 sysmt_project@sysmt prj,
 sysmt_system@sysmt sys
where
 ( sys.pid = prj.pid
  and
 mt.sysid = sys.sysid )
;

drop if exists view sysmt_usrview;
create view sysmt_usrview as
select
 u.uid as uid,
 u.dbuser as dbuser,
 u.username as username,
 u.userright as userright,
 (select
 count( distinct s.sid)
from
 sysmt_system@sysmt s,
 sysmt_prj2bgrp@sysmt p2g,
 sysmt_usr2bgrp@sysmt u2g
where
 ( ( p2g.pid = s.pid
 and
u2g.bgid = p2g.bgid )
  and
 u2g.uid = u.uid )
order by
 s.sid) as numsys,
 (select
 count( distinct p.pid)
from
 sysmt_project@sysmt p,
 sysmt_prj2bgrp@sysmt p2g,
 sysmt_usr2bgrp@sysmt u2g
where
 ( ( p2g.pid = p.pid
 and
u2g.bgid = p2g.bgid )
  and
 u2g.uid = u.uid )
order by
 p.pid) as numprj
from
 sysmt_user@sysmt u;


drop if exists view sysmt_systemview;
create view sysmt_systemview as
select
 sys.sysid as sysid,
 sys.sid as sid,
 sys.saptype as saptype,
 sys.dbtype as dbtype,
 sys.dbversion as dbversion,
 sys.sapversion as sapversion,
 sys.arch as arch,
 sys.category as category,
 sys.platform as platform,
 sys.status as status,
 sys.vip as vip,
 sys.nfsvip as nfsvip,
 sys.vipip as vipip,
 sys.vipif as vipif,
 sys.sysnr as sysnr,
 sys.scs as scs,
 sys.javaport as javaport,
 sys.smdid as smdid,
 sys.zoneA as zoneA,
 sys.zoneB as zoneB,
 sys.partA as partA,
 sys.partB as partB,
 sys.partC as partC,
 sys.partD as partD,
 sys.restartzones as restartzones,
 sys.sharedfs as sharedfs,
 sys.parthalog as parthalog,
 sys.sdbtype as sdbtype,
 sys.dbvip as dbvip,
 sys.dbvA as dbvA,
 sys.dbvB as dbvB,
 sys.slaid as slaid,
 prj.prjname as prjname,
 prj.pid as pid,
 sys.sysdesc as description,
 sys.mtinfo as mtinfo,
 (select
 count(*)
from
 sysmt_instance@sysmt i
where
 i.sysid = sys.sysid
) as numinst
from
 sysmt_system@sysmt sys,
 sysmt_project@sysmt prj
where
 sys.pid = prj.pid;


drop if exists view sysmt_mtmonth;
create view sysmt_mtmonth as
select
 mt.mid as mid,
 mt.status as status,
 p.prjname as prjname,
 p.pid as pid,
 s.sid as sid,
 date2str(mt.mtfrom,'%m') as month,
 date2str(mt.mtfrom,'%Y') as year
from
 sysmt_mt@sysmt mt,
 sysmt_system@sysmt s,
 sysmt_project@sysmt p
where
 ( mt.sysid = s.sysid
  and
 s.pid = p.pid );

drop if exists view sysmt_sysfwview;
create view sysmt_sysfwview as
select
 sfw.fwrid as fwrid,
 sfw.sysid as sysid,
 (select
 sysmt_system.sid as sid
from
 sysmt_system@sysmt sysmt_system
where
 sysmt_system.sysid = sfw.sysid
) as sid,
 (select
 sysmt_fwsg.sgname as sgname
from
 sysmt_fwsg@sysmt sysmt_fwsg
where
 sysmt_fwsg.sgid = sfw.sgidfrom
) as sgfrom,
 (select
 sysmt_fwsg.sgname as sgname
from
 sysmt_fwsg@sysmt sysmt_fwsg
where
 sysmt_fwsg.sgid = sfw.sgidto
) as sgto,
 (select
 sysmt_fwps.psname as psname
from
 sysmt_fwps@sysmt sysmt_fwps
where
 sysmt_fwps.psid = sfw.psid
) as portset
from
 sysmt_sysfw@sysmt sfw;


drop if exists view sysmt_threadview;
create view sysmt_threadview as
select
 t.thrid as thrid,
 tg.tgname as tgname,
 tg.tgid as tgid,
 t.created as created,
 t.shortdesc as shortdesc,
 t.description as description,
 t.remind as remind,
 bg.bgname as bgname,
 t.status as status
from
 sysmt_thread@sysmt t,
 sysmt_threadgroup@sysmt tg,
 sysmt_bgroup@sysmt bg
where
 ( t.tgid = tg.tgid
  and
 bg.bgid = t.bgid );

drop if exists view sysmt_masterhostview;
create view sysmt_masterhostview as
select
 h.hostname as masterhost,
 v2h.vip as vip,
 v2h.status as status
from
 sysmt_vip2host@sysmt v2h,
 sysmt_host@sysmt h
where
 v2h.hid = h.hid;

drop if exists view sysmt_mtbyday;
create view sysmt_mtbyday as
select
 sysmt_mt.mid as mid,
 date2str(sysmt_mt.mtfrom,'%d') as day
from
 sysmt_mt@sysmt sysmt_mt;
drop if exists view sysmt_prj2uid;
create view sysmt_prj2uid as
select
 p.prjname as prjname,
 u2g.uid as uid
from
 sysmt_project@sysmt p,
 sysmt_prj2bgrp@sysmt p2g,
 sysmt_usr2bgrp@sysmt u2g
where
 ( p2g.pid = p.pid
  and
 u2g.bgid = p2g.bgid );

drop if exists view sysmt_usrview2;
create view sysmt_usrview2 as
select
 u.uid as uid,
 u.dbuser as dbuser,
 u.username as username,
 u.userright as userright,
 (select
 count(*)
from
 sysmt_system@sysmt s,
 sysmt_prj2bgrp@sysmt p2g,
 sysmt_usr2bgrp@sysmt u2g
where
 ( ( p2g.pid = s.pid
 and
u2g.bgid = p2g.bgid )
  and
 u2g.uid = u.uid )
) as numsys
from
 sysmt_user@sysmt u;

drop if exists view sysmt_diskview;
create view sysmt_diskview as
select
 d.did as did,
 d.diskname as diskname,
 d.status as status,
 d.scandate as scandate,
 d.disksize as disksize,
 d.diskusage as diskusage,
 d.diskvg as diskvg,
 h.hostname as hostname
from
 sysmt_disk@sysmt d,
 sysmt_disk2host@sysmt d2h,
 sysmt_host@sysmt h
where
 ( d.did = d2h.did
  and
 d2h.hid = h.hid );

drop if exists view sysmt_usrview3;
create view sysmt_usrview3 as
select
 u.uid as uid,
 u.dbuser as dbuser,
 count(*)
from
 sysmt_user@sysmt u,
 sysmt_system@sysmt s,
 sysmt_prj2bgrp@sysmt p2g,
 sysmt_usr2bgrp@sysmt u2g
where
 ( ( p2g.pid = s.pid
 and
u2g.bgid = p2g.bgid )
  and
 u2g.uid = u.uid )
group by
 u.uid, u.dbuser;

drop if exists view sysmt_sid2uid;
create view sysmt_sid2uid as
select
 s.sid as sid,
 u2g.uid as uid
from
 sysmt_system@sysmt s,
 sysmt_prj2bgrp@sysmt p2g,
 sysmt_usr2bgrp@sysmt u2g
where
 ( p2g.pid = s.pid
  and
 u2g.bgid = p2g.bgid );

------------------
--- Procedures ---
------------------

drop if exists procedure newThreadGroup;
@
create procedure newThreadGroup(tgname in string(30),
     tgdesc in string(1000)) return int
begin
   var tgid int;
   :tgid = nextId('TGID');
   insert into sysmt_threadgroup ( tgid, tgname, tgdesc )
    values (:tgid, :tgname, :tgdesc);
   return :tgid;
end;
@

drop if exists procedure newSystemSet;
@
create procedure newSystemSet(setname in string(10),
     description in string(1000)) return int
begin
   var setid int;
   :setid = nextId('SETID');
   insert into sysmt_systemset ( setid, setname, description )
    values (:setid, :setname, :description);
   return :setid;
end;
@

drop if exists procedure newGroup;
@
create procedure newGroup(bgname in string(20),
     bgdesc in string(100)) return int
begin
   var bgid int;
   :bgid = nextId('BGID');
   insert into sysmt_bgroup ( bgid, bgname, bgdesc )
    values (:bgid, :bgname, :bgdesc);
   return :bgid;
end;
@

drop if exists procedure sysWfFire;
@
create procedure sysWfFire(sysid in int,
     bgname in string(20),
     dbuser in string(20),
     comment in string(500)) return int
begin
   var seqnr int;
   :seqnr = (select
 sysmt_sysworkflow.seqnr as seqnr
from
 sysmt_sysworkflow@sysmt sysmt_sysworkflow
where
 ( sysmt_sysworkflow.sysid = :sysid
  and
 sysmt_sysworkflow.bgid = (select
 sysmt_bgroup.bgid as bgid
from
 sysmt_bgroup@sysmt sysmt_bgroup
where
 sysmt_bgroup.bgname = :bgname
) )
);
   update sysmt_sysworkflow set status='Done', released=sysdate, comment=:comment, dbuser=:dbuser where ( sysid = :sysid
 and
seqnr = :seqnr );
   update sysmt_sysworkflow set status='Requested', assigned=sysdate where ( sysid = :sysid
 and
seqnr = :seqnr + 1 );
   return :seqnr + 1;
end;
@

drop if exists procedure impSys;
@
create procedure impSys(sid in string(10),
     sysdesc in string(1000)) return int
begin
   var sysid int;
   :sysid = getSysId(:sid);
   if :sysid = 0
   then
      :sysid = newSystem(:sid,'Unassigned','NA','NA','NA');
      update sysmt_system set sysdesc=:sysdesc where sysid = :sysid;
   else
   update sysmt_system set status='Xandria' where sid = :sid;
   end;
   return :sysid;
end;
@

drop if exists procedure newSystem;
@
create procedure newSystem(sid in string(30),
     prjname in string(20),
     category in string(10),
     platform in string(10),
     status in string(10)) return int
begin
   var pid int;
   var sysid int;
   var wfgid int;
   var seqnr int;
   var wfstatus string(10);
   var startdate datetime;
   :sysid = nextId('SYSID');
   :pid = getPid(:prjname);
   insert into sysmt_system ( sysid, sid, category, platform, status, pid )
    values (:sysid, :sid, :category, :platform, :status, :pid);
   cursor agCur as
      select
       bgid as bgid,
       seqnr as seqnr
      from
       sysmt_prj2workflow@sysmt sysmt_prj2workflow
      where
             pid = :pid

      order by
             seqnr;
   :wfstatus = 'Requested';
   :startdate = sysdate;
   while fetch agCur into (:wfgid, :seqnr) = true
   begin
      insert into sysmt_sysworkflow ( sysid, bgid, seqnr, assigned, status )
       values (:sysid, :wfgid, :seqnr, :startdate, :wfstatus);
      :wfstatus = 'Waiting';
      :startdate = null;
   end;
   close agCur;
   return :sysid;
end;
@

drop if exists procedure newThread;
@
create procedure newThread(tgname in string(30),
     shortdesc in string(100),
     bgname in string(20),
     remind in datetime) return int
begin
   var tgid int;
   var thrid int;
   :tgid = (select
 sysmt_threadgroup.tgid as tgid
from
 sysmt_threadgroup@sysmt sysmt_threadgroup
where
 sysmt_threadgroup.tgname = :tgname
);
   :thrid = nextId('THRID');
   insert into sysmt_thread ( thrid, tgid, shortdesc, created, remind, bgid, status )
    values (:thrid, :tgid, :shortdesc, sysdate, :remind, (select
 bgid as bgid
from
 sysmt_bgroup@sysmt sysmt_bgroup
where
 bgname = :bgname
), 'OPEN');
   return :thrid;
end;
@

drop if exists procedure impDisk;
@
create procedure impDisk(diskname in string(100),
     scandate in datetime,
     disksize in long,
     diskusage in string(100),
     diskvg in string(100),
     hostname in string(30)) return int
begin
   var did int;
   var hid int;
   var d2h int;
   :did = getDiskId(:diskname);
   :hid = getHostId(:hostname);
   if :did = null
   then
      :did = nextId('DID');
      insert into sysmt_disk ( did, scandate, status, diskname, disksize, diskusage, diskvg )
       values (:did, :scandate, 'new', :diskname, :disksize, :diskusage, :diskvg);
      if :hid != null
      then
            insert into sysmt_disk2host ( did, hid )
             values (:did, :hid);
      end;
   else
   update sysmt_disk set scandate=:scandate, status='valid', diskusage=:diskusage, diskvg=:diskvg where did = :did;
:d2h = (select
 count(*)
from
 sysmt_disk2host@sysmt sysmt_disk2host
where
 ( sysmt_disk2host.hid = :hid
  and
 sysmt_disk2host.did = :did )
);
if :d2h = 0 and :hid != null
then
insert into sysmt_disk2host ( did, hid )
 values (:did, :hid);
end;
   end;
   return :did;
end;
@

drop if exists procedure getSysId;
@
create procedure getSysId(sid in string(20)) return int
begin
   var actId int;
   var retval bool;
   :actId = 0;
   cursor actIdCur as
      select
       sysid as sysid
      from
       sysmt_system@sysmt sysmt_system
      where
             sid = :sid
;
   :retval = fetch actIdCur into (:actId);
   close actIdCur;
   return :actId;
end;
@

drop if exists procedure getDiskId;
@
create procedure getDiskId(diskname in string(20)) return int
begin
   var actId int;
   :actId = (select
 sysmt_disk.did as did
from
 sysmt_disk@sysmt sysmt_disk
where
 sysmt_disk.diskname = :diskname
);
   return :actId;
end;
@

drop if exists procedure getPidForSid;
@
create procedure getPidForSid(sid in string(20)) return int
begin
   var actId int;
   var retval bool;
   :actId = 0;
   cursor actIdCur as
      select
       pid as pid
      from
       sysmt_system@sysmt sysmt_system
      where
             sid = :sid
;
   :retval = fetch actIdCur into (:actId);
   close actIdCur;
   return :actId;
end;
@

drop if exists procedure copytab;
@
create procedure copytab(copyCond in int) return int
begin
   var copyCount int;
   var ca int;
   var cb string(30);
   :copyCount = 0;
   cursor copyCursor as
      select
       a as a,
       b as b
      from
       srctab@sysmt srctab
      where
             a = :copyCond
;
   while fetch copyCursor into (:ca, :cb) = true
   begin
      insert into desttab
       values (:ca, :cb);
      :copyCount = :copyCount + 1;
   end;
   return :copyCount;
end;
@

drop if exists procedure resetApproval;
@
create procedure resetApproval(mid in int)
begin
   var sid string(20);
   var sysid int;
   var pid int;
   var status string(20);
   delete from sysmt_mtapproval where mid = :mid;
   :status = (select
 sysmt_mtview.status as status
from
 sysmt_mtview sysmt_mtview
where
 sysmt_mtview.mid = :mid
);
   if :status != 'Claimed'
   then
      var agid int;
      :sid = (select
 sysmt_mtview.sid as sid
from
 sysmt_mtview sysmt_mtview
where
 sysmt_mtview.mid = :mid
);
      :sysid = (select
 sysmt_mt.sysid as sysid
from
 sysmt_mt@sysmt sysmt_mt
where
 sysmt_mt.mid = :mid
);
      :pid = getPidForSid(:sid);
      cursor agCur as
            select
             bgid as bgid
            from
             sysmt_prj2approval@sysmt sysmt_prj2approval
            where
                         pid = :pid
;
      while fetch agCur into (:agid) = true
      begin
            insert into sysmt_mtapproval ( mid, bgid, status )
             values (:mid, :agid, 'Requested');
      end;
      close agCur;
      update sysmt_mt set status='Requested' where mid = :mid;
   end;
end;
@

drop if exists procedure getBgid;
@
create procedure getBgid(bgname in string(20)) return int
begin
   var actId int;
   var retval bool;
   :actId = 0;
   cursor actIdCur as
      select
       bgid as bgid
      from
       sysmt_bgroup@sysmt sysmt_bgroup
      where
             bgname = :bgname
;
   :retval = fetch actIdCur into (:actId);
   close actIdCur;
   return :actId;
end;
@

drop if exists procedure deleteProject;
@
create procedure deleteProject(pid in int)
begin
   var sysid int;
   cursor sysCur as
      select
       sysid as sysid
      from
       sysmt_system@sysmt sysmt_system
      where
             pid = :pid
;
   while fetch sysCur into (:sysid) = true
   begin
      deleteSystem(:sysid);
   end;
   close sysCur;
   delete from sysmt_prj2approval where pid = :pid;
   delete from sysmt_prj2bgrp where pid = :pid;
   delete from sysmt_project where pid = :pid;
end;
@

drop if exists procedure sysWfReset;
@
create procedure sysWfReset(sysid in int) return int
begin
   var pid int;
   var seqnr int;
   var wfgid int;
   var wfstatus string(10);
   var startdate datetime;
   delete from sysmt_sysworkflow where sysid = :sysid;
   :pid = (select
 sysmt_system.pid as pid
from
 sysmt_system@sysmt sysmt_system
where
 sysmt_system.sysid = :sysid
);
   cursor agCur as
      select
       bgid as bgid,
       seqnr as seqnr
      from
       sysmt_prj2workflow@sysmt sysmt_prj2workflow
      where
             pid = :pid

      order by
             seqnr;
   :wfstatus = 'Requested';
   :startdate = sysdate;
   while fetch agCur into (:wfgid, :seqnr) = true
   begin
      insert into sysmt_sysworkflow ( sysid, bgid, seqnr, assigned, status )
       values (:sysid, :wfgid, :seqnr, :startdate, :wfstatus);
      :wfstatus = 'Waiting';
      :startdate = null;
   end;
   close agCur;
   return 0;
end;
@

drop if exists procedure myInOut;
@
create procedure myInOut(myIn in int,
     myOut out string(20)) return int
begin
   var p1 int;
   var p2 string(20);
   :myOut = 'TestString';
   return 42;
end;
@

drop if exists procedure nextId;
@
create procedure nextId(id in string(30)) return int
begin
   var idval int;
   update sysmt_id set idval=idval + 1 where id = :id return :idval = idval;
   return :idval;
end;
@

drop if exists procedure getPid;
@
create procedure getPid(prjname in string(100)) return int
begin
   var actId int;
   var retval bool;
   :actId = 0;
   cursor actIdCur as
      select
       pid as pid
      from
       sysmt_project@sysmt sysmt_project
      where
             prjname = :prjname
;
   :retval = fetch actIdCur into (:actId);
   close actIdCur;
   return :actId;
end;
@

drop if exists procedure impHost;
@
create procedure impHost(hostname in string(30),
     scandate in datetime,
     hostinfo in string(100),
     osinfo in string(100),
     cpuinfo in string(100),
     meminfo in string(100)) return int
begin
   var hid int;
   :hid = getHostId(:hostname);
   if :hid = null
   then
      :hid = nextId('HID');
      insert into sysmt_host ( hid, scandate, status, hostname, hostinfo, osinfo, cpuinfo, meminfo )
       values (:hid, :scandate, 'valid', :hostname, :hostinfo, :osinfo, :cpuinfo, :meminfo);
   else
   update sysmt_host set scandate=:scandate, status='valid', hostinfo=:hostinfo, osinfo=:osinfo, cpuinfo=:cpuinfo, meminfo=:meminfo where hid = :hid;
   end;
   return :hid;
end;
@

drop if exists procedure newFWPS;
@
create procedure newFWPS(psname in string(30)) return int
begin
   var psid int;
   :psid = nextId('PSID');
   insert into sysmt_fwps ( psid, psname )
    values (:psid, :psname);
   return :psid;
end;
@

drop if exists procedure newFileSysTmpl;
@
create procedure newFileSysTmpl(fstmplname in string(50),
     fstmpltype in string(10),
     fstmplrule in string(200),
     fstmpldesc in string(500)) return int
begin
   var tmplid int;
   :tmplid = nextId('TMPLID');
   insert into sysmt_filesystmpl ( tmplid, fstmplname, fstmpltype, fstmplrule, fstmpldesc )
    values (:tmplid, :fstmplname, :fstmpltype, :fstmplrule, :fstmpldesc);
   return :tmplid;
end;
@

drop if exists procedure newAddon;
@
create procedure newAddon(sysid in int,
     aotype in string(20),
     aoname in string(20)) return int
begin
   var aoid int;
   :aoid = nextId('AOID');
   insert into sysmt_addon ( aoid, aotype, aoname, sysid )
    values (:aoid, :aotype, :aoname, :sysid);
   return :aoid;
end;
@

drop if exists procedure newNFS;
@
create procedure newNFS(sysid in int,
     nfspath in string(100),
     nfsnode in string(100),
     nfsmount in string(100)) return int
begin
   var nfsid int;
   :nfsid = nextId('NFSID');
   insert into sysmt_nfs ( nfsid, nfspath, nfsnode, nfsmount, sysid )
    values (:nfsid, :nfspath, :nfsnode, :nfsmount, :sysid);
   return :nfsid;
end;
@

drop if exists procedure newDocument;
@
create procedure newDocument(doctype in string(10),
     docname in string(200)) return int
begin
   var docid int;
   :docid = nextId('DOCID');
   insert into sysmt_document ( docid, doctype, docname )
    values (:docid, :doctype, :docname);
   return :docid;
end;
@

drop if exists procedure newProject;
@
create procedure newProject(prjname in string(100),
     prjdesc in string(1000)) return int
begin
   var pid int;
   :pid = nextId('PID');
   insert into sysmt_project ( pid, prjname, prjdesc )
    values (:pid, :prjname, :prjdesc);
   return :pid;
end;
@

drop if exists procedure getHostId;
@
create procedure getHostId(hostname in string(20)) return int
begin
   var actId int;
   :actId = (select
 sysmt_host.hid as hid
from
 sysmt_host@sysmt sysmt_host
where
 sysmt_host.hostname = :hostname
);
   return :actId;
end;
@

drop if exists procedure newUserSearch;
@
create procedure newUserSearch(usname in string(30),
     usspec in string(100),
     dbuser in string(20)) return int
begin
   var usid int;
   var uid int;
   :usid = nextId('USID');
   :uid = getUid(:dbuser);
   insert into sysmt_usersearch ( usid, usname, usspec, uid )
    values (:usid, :usname, :usspec, :uid);
   return :usid;
end;
@

drop if exists procedure getUid;
@
create procedure getUid(dbuser in string(20)) return int
begin
   var actId int;
   var retval bool;
   :actId = 0;
   cursor actIdCur as
      select
       uid as uid
      from
       sysmt_user@sysmt sysmt_user
      where
             dbuser = :dbuser
;
   :retval = fetch actIdCur into (:actId);
   close actIdCur;
   return :actId;
end;
@

drop if exists procedure newUser;
@
create procedure newUser(dbuser in string(20),
     username in string(20),
     userdesc in string(1000),
     userright in string(10),
     usermail in string(100)) return int
begin
   var uid int;
   :uid = nextId('UID');
   insert into sysmt_user ( uid, dbuser, username, userdesc, userright, usermail )
    values (:uid, :dbuser, :username, :userdesc, :userright, :usermail);
   return :uid;
end;
@

drop if exists procedure newInstance;
@
create procedure newInstance(sysid in int,
     instnr in string(10),
     instvip in string(50),
     instsmd in string(10),
     instsaptype in string(10),
     instjavaport in string(10),
     instzone in string(50),
     instarch in string(10),
     instdisp in string(10)) return int
begin
   var instid int;
   :instid = nextId('INSTID');
   insert into sysmt_instance ( instid, instnr, instvip, instsmd, instsaptype, instjavaport, instzone, instarch, instdisp, sysid )
    values (:instid, :instnr, :instvip, :instsmd, :instsaptype, :instjavaport, :instzone, :instarch, :instdisp, :sysid);
   return :instid;
end;
@

drop if exists procedure newFileSysTmplEntry;
@
create procedure newFileSysTmplEntry(tmplid in int,
     fstype in string(50),
     fspath in string(100),
     fsvg in string(100),
     fslv in string(100),
     fsopt in string(100),
     fssizesmall in long,
     fssizebig in long) return int
begin
   var fsid int;
   :fsid = nextId('FSID');
   insert into sysmt_filesystmplentry ( fsid, tmplid, fstype, fspath, fsvg, fslv, fsopt, fssizesmall, fssizebig )
    values (:fsid, :tmplid, :fstype, :fspath, :fsvg, :fslv, :fsopt, :fssizesmall, :fssizebig);
   return :fsid;
end;
@

drop if exists procedure newFWSG;
@
create procedure newFWSG(sgname in string(30),
     sgdesc in string(500)) return int
begin
   var sgid int;
   :sgid = nextId('SGID');
   insert into sysmt_fwsg ( sgid, sgname, sgdesc )
    values (:sgid, :sgname, :sgdesc);
   return :sgid;
end;
@

drop if exists procedure newSysFW;
@
create procedure newSysFW(sgfrom in string(30),
     sgto in string(30),
     portset in string(30),
     sid in string(20)) return int
begin
   var fwrid int;
   :fwrid = nextId('FWRID');
   insert into sysmt_sysfw ( fwrid, sgidfrom, sgidto, psid, sysid )
    values (:fwrid, (select
 sgid as sgid
from
 sysmt_fwsg@sysmt sysmt_fwsg
where
 sgname = :sgfrom
), (select
 sgid as sgid
from
 sysmt_fwsg@sysmt sysmt_fwsg
where
 sgname = :sgto
), (select
 psid as psid
from
 sysmt_fwps@sysmt sysmt_fwps
where
 psname = :portset
), (select
 sysid as sysid
from
 sysmt_system@sysmt sysmt_system
where
 sid = :sid
));
   return :fwrid;
end;
@

drop if exists procedure deleteSystem;
@
create procedure deleteSystem(sysid in int)
begin
   var mid int;
   cursor midCur as
      select
       mid as mid
      from
       sysmt_mt@sysmt sysmt_mt
      where sysid = :sysid;
   while fetch midCur into (:mid) = true
   begin
      delete from sysmt_mtapproval where mid = :mid;
      delete from sysmt_mtlog where mid = :mid;
      delete from sysmt_mt where mid = :mid;
   end;
   close midCur;
   delete from sysmt_sys2set where sysid = :sysid;
   delete from sysmt_system where sysid = :sysid;
   delete from sysmt_instance where sysid = :sysid;
end;
@

drop if exists procedure getSetId;
@
create procedure getSetId(setname in string(20)) return int
begin
   var actId int;
   var retval bool;
   :actId = 0;
   cursor actIdCur as
      select
       setid as setid
      from
       sysmt_systemset@sysmt sysmt_systemset
      where setname = :setname;
   :retval = fetch actIdCur into (:actId);
   close actIdCur;
   return :actId;
end;
@

drop if exists procedure impVip2Host;
@
create procedure impVip2Host(vip in string(30),
     hostname in string(30),
     status in string(15))
begin
   var hid int;
   :hid = getHostId(:hostname);
   if :hid != null
   then
      delete from sysmt_vip2host where ( vip = :vip and hid = :hid );
      insert into sysmt_vip2host ( vip, hid, status )
       values (:vip, :hid, :status);
   end;
end;
@

drop if exists procedure newGroupSearch;
@
create procedure newGroupSearch(gsname in string(30),
     gsspec in string(100)) return int
begin
   var gsid int;
   :gsid = nextId('GSID');
   insert into sysmt_groupsearch ( gsid, gsname, gsspec )
    values (:gsid, :gsname, :gsspec);
   return :gsid;
end;
@

drop if exists procedure newMt;
@
create procedure newMt(sid in string(20),
     shortdesc in string(50),
     description in string(500),
     mtfrom in datetime,
     mtto in datetime,
     downfrom in datetime,
     downto in datetime,
     status in string(10),
     ticketnr in bigint(20),
     mttype in string(10),
     thrid in int) return int
begin
   var mid int;
   var sysid int;
   var pid int;
   var agid int;
   :mid = nextId('MID');
   :sysid = getSysId(:sid);
   insert into sysmt_mt ( mid, sysid, shortdesc, description, mtfrom, mtto, downfrom, downto, status, ticketnr, mttype, thrid )
    values (:mid, :sysid, :shortdesc, :description, :mtfrom, :mtto, :downfrom, :downto, :status, :ticketnr, :mttype, :thrid);
   :pid = getPidForSid(:sid);
   cursor agCur as
      select
       bgid as bgid
      from
       sysmt_prj2approval@sysmt sysmt_prj2approval
      where pid = :pid;
   while fetch agCur into (:agid) = true
   begin
      insert into sysmt_mtapproval ( mid, bgid, status )
       values (:mid, :agid, 'Requested');
   end;
   close agCur;
   return :mid;
end;
@

drop if exists procedure newSLA;
@
create procedure newSLA(slanr in string(30),
     shortdesc in string(100)) return int
begin
   var slaid int;
   :slaid = nextId('SLAID');
   insert into sysmt_sla ( slaid, slanr, shortdesc )
    values (:slaid, :slanr, :shortdesc);
   return :slaid;
end;
@

drop if exists procedure impFS;
@
create procedure impFS(sid in string(20),
     fspath in string(100),
     fssize in long)
begin
   var sysid int;
   :sysid = getSysId(:sid);
   if :sysid != null
   then
      update sysmt_filesys set fssize=:fssize where ( sysid = :sysid
 and
fspath = :fspath );
   end;
end;
@